//demo file: Computes the Moreau envelope and the proximal mapping
//of the absolute value function on the interval [-1,1]
//Function demoed: pl_me_direct
mode(-1);
clear ff
//Define the function whose transforms will be computed
function f=ff(x),f= abs(x),endfunction;

X=(-1:0.1:1)';//define the grid on which to evaluate the function
S=X;//Select the dual grid to be the same as the primal grid
n=length(X);m=length(S);
//evaluate the function on the grid. If your function does
//not allow for vector input, use the feval function.
f=ff(X);
//Computes the Moreau envelope
[M,p,P] = pl_me_direct(X, f, S);

//plot the function f, and its moreau envelope M
scf();
plot2d(X,[f,M],rect=[X(1),min(f),X(length(X)),max(f)]);p=get("hdl");
labels=["f","M"];legends(labels,[1:size(labels,2)],opt="ul");
q=get("hdl");
thickness=[2;1;1;1];line_style=[4;1;1;1];
for i=1:size(labels,2)
	p.children(i).thickness=thickness(i);
	p.children(i).line_style=line_style(i);
	q.children(2*i).thickness=thickness(i);
	q.children(2*i).line_style=line_style(i);
end
p.parent.x_label.text="x";
p.parent.y_label.text="f and M";
xtitle("Moreau envelope of the absolute value");

//plot P the proximal mapping of f
scf();
clear Pv ;
Pv=matrix(S(P),n,m);//convert from index to value
plot2d(S,Pv',style=-1 * ones(1,m));
plot2d(S,Pv');
xtitle(['Proximal mapping'],'S','P');
