mode(-1);

// Demo file: Demonstrate the conjugate operation of a GPH function as a
// mirroring of the graph of the subdifferential over the line y=x.

gphA = [-1,  0, 0, 1, 2; ..
        -1, -1, 0, 0, 2; ..
         1,  0, 0, 0, 1];
gphB = gph_lft(gphA);

plqA = plq_gph(gphA);
plqB = plq_gph(gphB);

// Plot the functions.
scf();
subplot(2,2,1);
plq_plot(plqA);
xtitle("PLQ function f");
subplot(2,2,2);
plq_plot(plqB);
xtitle("PLQ conjugate of f");
subplot(2,2,3);
gph_plot(gphA);
xtitle("GPH subdifferential of f");
subplot(2,2,4);
gph_plot(gphB);
xtitle("GPH conjugate of f");
