mode(-1);

// Demo file: Demonstrate the proximal average of two GPH functions.

G1 = [-1 0 0 1; -1 -1 0 2; 1 0 0 1];
G2 = [0 0; 0 1; 5 5];

fWnd = scf();
plq_plot(plq_gph(G1));
zoom_rect([-5, 0, 5, 20]);
xtitle("Proximal average (separate windows, click to begin)");

dfWnd = scf();
gph_plot(G1);
xtitle("Subdifferential of PA (separate windows, click to begin)");

xclick();

for lambda = 0:0.025:1
    pa = gph_pa(G1, G2, lambda);

    scf(fWnd);
    drawlater();
    clf();
    plq_plot(plq_gph(pa));
    xtitle(sprintf("Proximal average, lambda = %.4f", lambda));
    zoom_rect([-5, 0, 5, 20]);
    drawnow();

    scf(dfWnd);
    drawlater();
    clf();
    gph_plot(pa);
    //plot2d([-1,1], [3,-3], -1);
    zoom_rect([-1, -1.5, 1, 2]);
    xtitle(sprintf("Subdifferential of PA, lambda = %.4f", lambda));
    drawnow();

    if lambda == 0 then
      sleep(1000);
    else
      sleep(100);
    end;
end;
