mode(-1);
//plots the Lasry-Lions double envelope using
//fast algorithms and plq algorithms
//note the error introduced by fast algorithms at the boundary
//of the interval
clear ff
function f=ff(x),f=abs(abs(x)-1),endfunction;

X=(-2.5:0.01:2.5)';S=X;
//need 0<mu<lambda
lambda=0.7;mu=0.4;// http://oldweb.cecm.sfu.ca/projects/CCA/FCT/demo/HTML/
//mu=0.9;lambda=0.001;
f=ff(X);
L = pl_ll(X,f,S,lambda,mu,pl_me_direct);

//plot f,M
scf();
subplot(1,1,1);
subplot(1,2,1);
plot2d(X,[abs(abs(X)-1),L],style=[1,2]);//p=get("hdl");
legends(['f','ll'],style=[1,2],opt="ur");
xtitle("Lasry-Lions double envelope using fast algorithms","x");

//PLQ package
pplq=[-1,0,-1,-1;0,0,1,1;1,0,-1,1;%inf,0,1,-1];
p=plq_eval(pplq,X);
qplq=plq_ll(pplq,lambda,mu);//Lasry-Lions
q=plq_eval(qplq,X);

subplot(1,2,2);
plot2d(X,[p,q],style=[1,2]);
legends(['f','ll'],style=[1,2],opt="ur");
xtitle("Lasry-Lions double envelope using PLQ algorithms","x");

