mode(-1);

// Demo file: Demonstrate the operation of the plq_coSplit algorithm,
// displaying the decomposition of f, the conjugation of the individual
// g_i's, and the pointwise maximum.

plqf = [-1,0,-1,-1; 0,1,2,1; 1,0,0,1; %inf,1,-2,2];
scf(); plq_plot(plqf);
xtitle("The original PLQ function f (click to continue)")
xclick();

// Compute g_i's.
drawlater();
clf();
plq1 = plq_split(plqf, 1); subplot(1,4,1); plq_plot(plq1);
plq2 = plq_split(plqf, 2); subplot(1,4,2); plq_plot(plq2);
xtitle("Decomposition of f into g_i (click to continue)");
plq3 = plq_split(plqf, 3); subplot(1,4,3); plq_plot(plq3);
plq4 = plq_split(plqf, 4); subplot(1,4,4); plq_plot(plq4);
drawnow();
xclick();

// Compute g_i*'s.
drawlater();
clf();
cnj1 = plq_lft(plq1); subplot(1,4,1); plq_plot(cnj1);
cnj2 = plq_lft(plq2); subplot(1,4,2); plq_plot(cnj2);
xtitle("Conjugation of g_i''s (click to continue)");
cnj3 = plq_lft(plq3); subplot(1,4,3); plq_plot(cnj3);
cnj4 = plq_lft(plq4); subplot(1,4,4); plq_plot(cnj4);
drawnow();
xclick();

// Compute max g_i*.
cnj = plq_max(cnj1, cnj2);
cnj = plq_max(cnj, cnj3);
cnj = plq_max(cnj, cnj4);
drawlater();
clf();
xtitle("Pointwise maximum of the conjugates (click to continue)");
plq_plot(cnj);
drawnow();
xclick();

// Compute (max g_i*)*.

co = plq_lft(cnj);
drawlater();
clf();
xtitle("Conjugate of the maximum is the convex hull");
plq_plot(plqf, co);
drawnow();
