mode(-1);

// Demo file: Compute the Rockafellar function R(A,a(k)) of an operator A
// and plot the function for each value of k.

a = 1:5;
bm = [-10,-4, 1, 2, 5];
bp = [- 5, 0, 2, 4, 7];
B = [a;bm;bp];
R = [];
for i = 1:5
  R(:,:,i) = plq_rock(B, i);
end;

// Plot the functions.
scf();
x = linspace(-10, 10, 200)';
y = [];
for i = 1:5
  y(:,i) = plq_eval(R(:,:,i), x);
end;
plot2d(x, y, rect=[-2, -10, 6, 40]);
p = get("hdl");
fgs = [3,2,1,3,2,1,3,2,1];
fgs = [1,2,3,4,5,1,2,3,4];
thk = [2,2,2,2,2,1,1,1,1];
for i = 1:5
  p.children(i).foreground = fgs(10-i);
  p.children(i).thickness = thk(10-i);
end;
xtitle("Example of Rockafellar functions of an operator", "x", "R");
legend("a(k)=1", "a(k)=2", "a(k)=3", "a(k)=4", "a(k)=5");
