mode(-1)

animDelay = 1;

function z=f(x,y,lambda)//pa of indicator of orthogonal subspaces Y=R x {0}
    if lambda==0 then 
        if y==0 then z=zeros(x); else z=%inf*ones(x);end;
    elseif lambda==1 then 
        if x==0 then z=zeros(x); else z=%inf*ones(x);end;
    else 
        z = lambda * x.^2 /(2*(1-lambda)) + (1-lambda)*y.^2 /2/lambda;
    end;
endfunction

demoMode = x_choose(["Grid", ...
		    msprintf("Animation (%2.1fs delay)", animDelay), ...
		    "Animation (click)"], ...
                    "How would you like to view the PA?");

if (demoMode ~= 0) then
      tic();
      th=1;
      
      fig=scf();
      drawlater();
      
      npts=50;xs=linspace(-5,5,npts);ys=xs;[Xs,Ys] = ndgrid(xs,ys);//small set
      npts=200;xl=linspace(-5,5,npts);yl=xl;[Xl,Yl] = ndgrid(xl,yl);//large set
      n=1;lset=linspace(0,1,n+2);lset=lset(2:$-1);
      lset=[0.0001,0.1,0.3,0.7,0.9,1-0.0001];
      //lset=[0.1];
      lsize=length(lset);
      
      n=length(lset);nc=16;zub=30;iii=[1:2:2*n];
      fig.color_map=jetcolormap(nc);
      clf();
      i=1;stp=ceil(length(lset)/10);

      if (demoMode == 3) then
          msg = "Plotting in progress (Click plot to continue)";
      else
          msg = "Plotting in progress";
      end;
      beginProgress(%f, msg);

      if (demoMode == 1) then
	    subplot(2,3,2);
	    xtitle("Proximal Average (a subspace to its conjugate)");
      elseif (demoMode == 2) then
	    realtimeinit(0.5);
      end;
      
      for lambda=lset
	    colour=ceil(lambda*nc);
	    if lambda < 0.01 | lambda > 1-0.01 then
		  colour=-colour;x=xl;y=yl;X=Xl;Y=Yl;
	    else 
		  x=xs;y=ys;X=Xs;Y=Ys;
	    end;
	    z=f(X,Y,lambda);
	    ii=find(z==%inf);z(ii)=zub-0.001;
	    ii=find(z>zub);z(ii)=%inf;
	    
	    if (demoMode == 1) then
		  subplot(2,3,i);
	    else
		  clf();
		  if (i == lsize) then
			xtitle(msprintf("Proximal Average (a subspace to its conjugate)"));
		  else
			xtitle(msprintf("Proximal Average (a subspace to its conjugate) %d/%d<br/>hi", ...
					i, lsize));
		  end;
	    end;
	    plot3d(x,y,z,flag=[colour,1,4],ebox=[-5,5,-5,5,0,zub]);
	    //xset("colormap",jetcolormap(nc));
	    h=gce();h.hiddencolor=colour;
	    h.parent.box="off";
	    if (demoMode == 2) then
		  realtime(i);
	    end;
	    if modulo(i,stp)==0 then
		  drawnow();
		  showProgress(i/lsize, %f, msg);
		  drawlater();
	    end;
	    if (demoMode == 3 & i ~= lsize) then
		  xclick();
	    end;
	    
	    i=i+1;
      end;

      finishProgress();
      //subplot(n,2,4);colorbar(0,1);
      drawnow();
      toc()
end;
