//cd ~/Desktop/CCA/main/yves
//exec("me.sci");//loads lft.sci too

s=stacksize();
if (s(1) < 1.5e8) then
  if (msscanf(getversion(),"%*7s%f") < 5.2) then
    stacksize(1.5e8);
  else
    stacksize("max");
  end;
end;
clear s;clear time;
//do not include direct for n>4000, it paginates  
N=[1000:2000:30000]';includeDirect=%f;//full test
//N=[1000:1000:5000]';includeDirect=%f;//full test
//N=[10:10:100]';includeDirect=%t;//for testing
//N=[200:200:4000];includeDirect=%t;

isEqual = %t;

function y = ff(x), y =x.^2 /2, endfunction;
function s = dff(x), s = x, endfunction;

//1d timing
for i=1:length(N)
	n=N(i);
	printf("n= %d ",n);
	Xr=(-10:20/(n-1):10)';Sr=dff(Xr);
	f=ff(Xr);
	printf("llt: ");timer();M1 = pl_me_llt(Xr, f, Sr);time(i, 1) = timer();printf("Ok ");
	printf("pe: ");timer();M2 = me_pe_d(f);time(i, 2) = timer();printf("Ok ");
	printf("nep: ");timer();M3 = pl_me_nep(Xr, f, Sr);time(i, 3) = timer();printf("Ok ");
	printf("plt: ");timer();[M4,z] = pl_me_plt(Xr, ff, dff);time(i, 4) = timer();printf("Ok ");
	if (includeDirect), printf("direct: ");timer();M5 = pl_me_direct(Xr, f, Sr);time(i, 5) = timer();printf("Ok");end;
	
	//isEqual = isEqual & isequal(M1,M2,M3,M4,M5);
	//if ~isEqual, break; end;
	printf("\n");
end

//test results
// if ~isEqual 
// 	printf("Error! For i=%i not all methods returned the same result\n",i);
// end

//plot
if includeDirect, labels =["llt","pe","nep","plt","direct"];else labels =["llt","pe","nep","plt"];end;
clear cst;for i=1:size(time,2);coef=regress(N,time(:,i));cst(i)=coef(2);end;//compute constant
[s,k]=gsort(cst,'r','i');
l=labels(k)';
for i=1:size(time,2);printf("%s: C=%f\n",l(i),s(i));end;//print by decreasing efficiency

scf();
plot2d(N,time(:,k));p=get("hdl");
legends(labels(k),[1:size(labels,2)],opt="ul");
q=get("hdl");
if includeDirect ,thickness=[1;2;1;1;1];line_style=[1;1;2;3;4]; else thickness=[1;2;1;1];line_style=[1;1;2;3];end;
for i=1:size(labels,2)
	p.children(i).thickness=thickness(i);
	p.children(i).line_style=line_style(i);
	q.children(2*i).thickness=thickness(i);
	q.children(2*i).line_style=line_style(i);
end
p.parent.x_label.text="n";
p.parent.y_label.text="CPU seconds";
xtitle('Fast Moreau Envelope Algorithms');
