function [Xu,ku] = epsUnique(X,eps,keepLast)
  //remove all indices i that are nonunique up to epsilon
  //i.e. Xu verifies X(i)-X(j)>eps
  //ku are the indices that are kept i.e. unique up to eps
  //if |X(i)-X(i+1)|<eps, index i is kept and index i+1 discarded
  //only exception is when keepLast==%t then we force keeping the
  //last index
  if argn(2)<3 then keepLast=%f;end;
  Y = round(X / eps);
  [Yu,ku]=unique(Y);
  n = length(X);
  if keepLast & ku($)==n-1 then
    //replace last unique index with last index
    ku($)=n;
  end
  Xu = X(ku);
endfunction