function b = isEqual2(x, y)
  // Compares whether two matrices are equal, including infinities,
  // and, unlike isequal, tests floating point numbers properly.
  // Returns a scalar.  Returns false if the matrix contains NaNs.
  eps=1E-6;//precision under which numbers are considered equals
  if or(size(x)~=size(y)) then 
    b=%f;
  else
    i = abs(x - y) >= eps;
    if or(sign(x(i)) ~= sign(y(i))) then
  //  if or(sign(x) ~= sign(y)) then    
      b = %f;
    else
      b = and(abs(x - y) < eps | (isinf(x) & isinf(y)));
    end;
  end;
endfunction