function [T,ti,y] = copaCompute(f0,f1,rect,la,x,ind)
  //f0,f1: plq functions
  //la: lambdaSet
  //x: xSet
  //ind: index of method to use. If missing use all 5 methods and return a list
  //T: matrix if ind present, list of matrices if ind is missing
  //ti: array storing the time for each method
  if argn(2) < 5 then inds=1:5; else inds=ind;end;
  //printf("Computing\n");
  Y=copaSetup(f0,f1,la,x);
  //beginProgress();
  ny=length(x);
  ti=list();T=list();
  for i=inds,
    tic();
    [T(i),y]=plq_pa_Y(x,la,Y,ny,rect,i);
    ti(i)=toc();
    if size(T(i)) == [0 0] then
        T(i)=null();
        ti(i)=null();
    end;
    //showProgress(i/5);
  end
  
  if find(ind==6) then
    // Calculate T using explicit formula given by pa_lambda_at
    tic();  
    T($+1)=-ones(T(1));  
    for i=1:1:size(x,1)
          for j=1:1:size(y,1)
           T($)(j,i)=pa_lambda_at(x(i),y(j),f0,f1);
           //printf("x=%f, y=%f,l=%f \n",x(i),y(j),T($)(j,i));
          end;
          //printf("\n");
    end;
    ti($+1)=toc();
  end  
  //finishProgress();
endfunction