function cst=dispEff(N,time,labels,strTitle)
  //N: row vector of input sizes
  //time: size(N,2)*p matrix containing timing of N experiments for p algorithms
  //labels: array of string storing the name of each algorithm. Algorithm labels(i) ran in time(:,i) for
  //  input of size N(:)
  //cst: list of slope coefficients if N is a vector, or time if N is a number
      printf("Computation %s:\n",strTitle);
      clear cst;
      if size(time,1) > 1 then//algorithms compared several values: N is a vector
        for i=1:size(time,2);
            //remove infinity values
            k=find(~isinf(time(:,i)));
            Nk=N(k);timek=time(:,i);timek=timek(k);
            coef=regress(Nk,timek);
            cst(i)=coef(2);
        end;//compute constant
        [s,k]=gsort(cst,'r','i');
        l=labels(k)';
        for i=1:size(time,2) do
            printf("C=%f %s\n",s(i),l(i));
        end;//print by decreasing efficiency      
      else//algorithms compared on a single size: N is a number
      	  cst=time;
      	  dispOrder(time',labels);
      end
//      if size(time,1)==1 then//algorithms compared on a single size: N is a number
//       	  dispOrder(time',labels);
//      else//algorithms compared several values: N is a vector
//          [s,k]=gsort(cst,'c','i');
//          l=labels(k)';
//          for i=1:size(time,2) do
//              printf("%s: C=%f\n",l(i),s(i));
//          end;//print by decreasing efficiency
//      end
endfunction