function gphstar = gph_lft(gph,check)
  //compute the conjugate
  //gph: function in gph format
  //check: boolean: %t to check gph structure (disable for benchmarking)
  if argn(2)<2 then check=%t;end;
  if check then
    [b,n] = _gph_check(gph);
    if ~b then warning("Unconsistent gph structure in gph_lft");end;
  end      
  //invert the graph of partial f to obtain partial f*
  //do not multiply 3rd row (values of f) to avoid 0*%inf giving %nan
  gphstar = [0 1; 1 0] * gph(1:2,:);
  x = gph(1,:);s=gph(2,:);f=gph(3,:);
  gphstar(3,:)= s.*x -f;
  //fix bounded domain
  if n>2 then//no fix needed for full domain or singleton
    B = gph_isBounded(gphstar);
    if B(1,1) then gphstar(3,1)=%inf;end;
    if B(1,2) then gphstar(3,$)=%inf;end;
  end
  B = gph_isBounded(gph);
  if B(1,1) then gphstar(3,1)=s(1)*x(1)-f(2);end;
  if B(1,$) then gphstar(3,$)=s($)*x($)-f($-1);end;    
endfunction