function M = pl_lft_direct_2d (Xr, Xc, f, Sr, Sc)
	//O(N^(3/2)) = O(n^3) complexity with N=n^2 and n=length(Xr)=length(Xc)=length(Sr)=length(Sc)
	//we use the separability of the Euclidean norm to reduce from n^4 to n^3
	[b,s]=checksize(length(Xr),length(Xc),size(f),'pl_lft_direct_2d');
	if ~b, cerror(s); M = []; return; end;
	r1 = ones(size(Xr, 1), size(Sc, 1));
	for i=1:length(Xr)
		F = pl_lft_direct(Xc, f(i,:)', Sc);//quadratic cost
		r1(i,:) = -F';//linear cost since F is a vector
	end
	M = ones(size(Sr, 1), size(Sc, 1));
	for i=1:size(Sc, 1)
		M(:,i) = pl_lft_direct(Xr, r1(:,i), Sr);//quadratic cost
	end
endfunction