function [Conj]=pl_lft_llt(X,Y,S,isconvex,fusionopt)
	if (argn(2)<4) then isconvex=%f;fusionopt=1;
	elseif (argn(2)<5) then fusionopt=1;//scilab syntax for fast execution
	elseif (fusionopt~=0) then fusionopt=1;//programming syntax for linear-time execution
	end;
	if (Y == %inf.*Y | Y == %inf.*(-1.*Y))
		Conj = %inf.*(-1.*Y);
	else
		if (~isconvex) then
			[XX,YY]=pl_bb(X,Y); // Compute the convex hull (input sensitive algorithm)
		else
			XX=X;YY=Y;
		end;
		h=size(XX,1);
		C=(YY(2:h)-YY(1:h-1))./(XX(2:h)-XX(1:h-1)); // Compute the slopes associated with the primal points
		if fusionopt == 1 then
			[H]=_pl_fusionsci(C,S);// Merge sequences C and S
		else
			[H]=_pl_fusion(C,S); 
		end
		// j=H(i,1) is the first indice of the point X(j) such that the line
		// with slope S(i) supports the epigraph of the function at X(j).
		Conj= S .* XX(H(:,1)) -YY(H(:,1));
	end
endfunction