function M = pl_lft_llt_2d (Xr, Xc, f, Sr, Sc, isconvex)
	if (argn(2)<6) then isconvex=%f;end;//default to nonconvex

	//O(N) = O(n^2) complexity with N=n^2 and n=length(Xr)=length(Xc)=length(Sr)=length(Sc)
	//we use the separability of the Euclidean norm to reduce from n^3 to n^2
	[b,s]=checksize(length(Xr),length(Xc),size(f),'pl_lft_llt_2d');
	if ~b, cerror(s); M = []; return; end;
	r1 = ones(size(Xr, 1), size(Sc, 1));
	for i=1:length(Xr)
		F = pl_lft_llt(Xc, f(i,:)', Sc, isconvex);//quadratic cost
		r1(i,:) = -F';//linear cost since F is a vector
	end
	//
	M = ones(size(Sr, 1), size(Sc, 1));
	for i=1:size(Sc, 1)
		M(:,i) = pl_lft_llt(Xr, r1(:,i), Sr, isconvex);//quadratic cost
	end
endfunction