//should be triveral to expand it to the nth dimension.
function M = pl_lft_llt_3d (Xr, Xc, Xt, f, Sr, Sc, St, isconvex)
	if (argn(2)<8) then isconvex=%f;end;//default to nonconvex
	[b,s]=checksize(length(Xr),length(Xc),size(f),'pl_lft_llt_3d');
	if ~b, cerror(s); M = []; end;
	
	//Formula:
	//Conj = Sup_Xr [XrSr + Sup_Xc [XcSc + Sup_Xt [XtSt - f(X)]]]
	
	//hyper matrices
	r1 = ones(size(Xr, 1), size(Xc, 1), size(Xt,1)); //h = Sup_Xt [XtSt - f(X)] where X = <Xr,Xc,Xt>
	r2 = ones(size(Xr, 1), size(Xc, 1), size(Xt,1)); //q = Sup_Xc [XcSc + h] 
	r3  = ones(size(Sr, 1), size(Sc, 1), size(St,1)); //p = Sup_Xr [XrSr + q] 
	
	for j=1:length(Xr),
	   for i=1:length(Xc),
	      //the column vector v is required to store the data from f(j,i,:)', we 
	      //cannot directly use f(j,i,:)' since it outputs the data in a nonvector form.
	      v = ones(size(f,3),1); 
	      v(:) = f(j,i,:);
      		F = pl_lft_llt(Xt, v, St, isconvex);
      		r1(j,i,:) = -F';
	   end
	end

	for j=1:length(Xr),
		for k=1:length(Xt),
			v = ones(size(r1,2),1);
		v(:) = r1(j,:,k);
			F = pl_lft_llt(Xc, v, Sc, isconvex);
			r2(j,:,k) = -F';
		end
		end
	
	for i=1:length(Sc),
	   for k=1:length(St),
	     	v = ones(size(r2,1),1);
	      v(:) = r2(:,i,k);
      		r3(:,i,k) = pl_lft_llt(Sr, v, Sr, isconvex);
	   end
	end
	
	M = r3;
endfunction