//for comparison purposes only
function M = pl_me_brute_2d (Xr, Xc, f, Sr, Sc)
	//quadratic complexity O(n^4) in n when n=length(Xr)=length(Xc)=length(Sr)=length(Sc)
	[b,s]=checksize(length(Xr),length(Xc),size(f),'pl_me_brute_2d');
	if ~b, cerror(s); M = []; return; end;
	[n1,n2]=size(f);m1=length(Sr);m2=length(Sc);
	M=zeros(m1,m2);
	for p1=1:m1
		for p2=1:m2
			//Compute phi(p1,p2,:,:)
			t1 = (Xr-Sr(p1)).^2 * ones(1,n2);//matrix with same column vector (p1-q1).^2 for all q1 size n1*n2
			t2 = ones(n1,1) * ((Xc-Sc(p2)).^2)';//matrix with same row vector (p2-q2).^2 for all q2 size n1*n2
			t = t1 + t2 + f;//matrix(q1,q2) = (p1-q1)^2 + (p2-q2)^2 + f(q1, q2) size n1*n2
			M(p1,p2) = min(t);//quadratic cost O(n^2)
		end;
	end;
endfunction