function [M,p,P] = pl_me_direct(X, f, S) 
	//all vectors are column vectors; requires O(n^2) storage
	t1 = X * ones(1,size(S,1));//size n x m
	t2 = ones(size(X,1),1) * S';//size n x m
	t3 = (t1 - t2).^2;//||X(i) - S(j)||^2
	
	t4 = f * ones(1,size(S,1));//size n x m
	t=t3+t4;//||X(i) - S(j)||^2 + f(i,j)
	[ M, p ] = min( t, 'r')';//only gives a selection in P not all argmin
	M=M';

	[outargn ,inargn] = argn();
	if (outargn > 1) //skip computation of the full prox mapping when not required
		n=size(X,1);m=size(S,1);
		P = zeros(n,m);
		for j=1:1:m,
			tmp = find(t(:,j)==M(j),-1)';//find the full argmin
			P(:,j) = tmp(1);//fill all columns
			P(1:size(tmp,1),j) = tmp;//case argmin multivalued, fill first rows
		end;
	end;
endfunction