//Main function: Moreau envelope of bivariate function (not necessarily convex)
function [M,g,Conjpartial,Conj] = pl_me_llt_2d(Xr, Xc, f, Sr, Sc)
	[b,s]=checksize(length(Xr),length(Xc),size(f),'pl_me_llt_2d');
	if ~b, cerror(s); M = []; return; end;
	// step 1.- compute g for Moreau Envelope
// 	for i = 1:size(f, 1)
// 		for j = 1:size(f, 2)
// 			g(i, j) = (Xr(i)*Xr(i) + Xc(j)*Xc(j) + f(i, j)) / 2;
// 		end
// 	end
	[X,Y]=ndgrid(Xr.^2,Xc.^2);g=(X+Y+f)/2;clear X Y;//equivalent to above loop
	
	// step 2.- get the partial conjugates by row
	Conjpartial = ones(size(Xr,1),size(Sc,1));
	if (length(Xc) > 1)
		for i = 1:size(Xr,1)
			Conjpartial(i,:) = -1 .* pl_lft_llt(Xc, g(i,:)', Sc)';
		end
	else
		for i = 1:size(Sr,1)
			Conjpartial(:,i) = g(:, 1);
		end
	end

	// step 3.- get the partial conjugates by column
	Conj = ones(size(Sr,1),size(Sc,1));
	for j = 1:size(Sc,1)
		Conj(:,j) = pl_lft_llt(Xr, Conjpartial(:,j), Sr);
	end

	// step 4.- get Moreau Envelope
// 	for i = 1:size(Sr,1)
// 	  for j = 1:size(Sc,1)
// 	    M(i,j) = Sr(i)*Sr(i) + Sc(j)*Sc(j) - 2 * Conj(i,j);
// 	  end
// 	end
	[Sx,Sy]=ndgrid(Sr.^2,Sc.^2);M=Sx+Sy - 2 * Conj;clear Sx;clear Sy;//equivalent to above loop
endfunction