//Moreau envelope of a bivariate convex function
function M = pl_me_nep_2d(Xr, Xc, f, Sr, Sc)
	[b,s]=checksize(length(Xr),length(Xc),size(f),'pl_me_nep_2d');
	if ~b, cerror(s); M = []; return; end;
	M = zeros(size(Sc, 1), size(Sr, 1));
	MY = M;
	// rows first
	for i=1:size(f, 1)
		MY(:,i) = pl_me_nep(Xr, f(i,:)', Sr);//avoid transpose, same as MY(i, :) = pl_me_nep(Xr, f(i,:)', Sr)';
	end
	// columns next	
	for j=1:size(Sr, 1)
		M(:, j) = pl_me_nep(Xc, MY(j,:)', Sc);//avoid transpose, same as M(:, j) = pl_me_nep(Xc, MY(:, j), Sc);
	end
endfunction