//main function: parabolic envelope of a bivariate function on
//a grid
function [M] = pl_me_pe_2d(x0, xn, y0, yn, f)
	//X must be a regular grid and S=X
	nx=size(f,1);ny=size(f,2);
	hx=(xn-x0)/(nx-1);
	hxsqr=hx^2;
	hy=(yn-y0)/(ny-1);
	hysqr=hy^2;
	//recover non integer partition 
	//using M(x_j)=h^2 * min_i [ ||j-i||^2 + f(x_0+i*h)/h^2]
	M= pl_me_pe2d_d(hx,hy,f);
endfunction