function F = op_fitz_direct_do(A, n, x, xstar)
  if (n == 1) then
    F = x * xstar';
    return;
  end;

  Fprev = op_fitz_direct_do(A, n - 1, A(1,:)', xstar);
  m = size(A, 2);
  Nx = size(x, 1);
  Nxstar = size(xstar, 1);
  F = zeros(Nx, Nxstar);

  for i = 1:Nx
    xi = x(i);
    for j = 1:Nxstar
      xstarj = xstar(j);

      sup = -%inf;
      for k = 1:m
        z = Fprev(k,j) + xi*A(2,k) - A(1,k)*A(2,k);
        sup = max(sup, z);
      end;
      F(i, j) = sup;
    end;
  end;
endfunction