function [_f,_g,ind] = _costf_me(y,ind,x,lambda),
  //input: 
  //y: point to evaluate at
  //ind=1: not output; ind=2: only compute f; ind=3: only compute g; ind=4: compute f and g
  //x,lambda: parameters used in the computation (real numbers)
  //WARNING: f,df are passed by dynamic scoping (defined in opt_me)
  //output: 
  //_f: function value at y
  //_g: derivative value at y
  //ind<0 cannot compute f at x; ind=0 interrupt optimization
  _f = f(y) + (x-y)^2/(2*lambda);
  _g = df(y) + (y-x)/lambda;
  //workaround bug in optim with method 'nd': when gradient is exactly 0 errors out with optim: Wrong input parameters.
  //workaround is to replace 0 with a small value
  if _g==0 then _g=1E-20;end;
  //what do we return for a point outside the domain? The choice below while not the most
  //efficient works on our examples.
  if _f==%inf then _f=number_properties('huge');_g=%inf;end;
    
  //printf("i=%i, y=%f, g=%f, f=%f\n",i,y,_g,_f);
endfunction