function [y,argmin] = opt_ic(f1,df1,domf1,f2,df2,domf2,x,output)
  //computes the inf convolution of f1 and f2 evaluated on vector x
  //f1, f2: univariate functions continuous but (potentially) nonsmooth
  //df1, df2: univariate functions: derivatives of f1 df1=f1', and f2 df2=f2'
  //domf1,domf2: intervals [lb,ub] storing the domain of f1 (resp. f2)
  //x: vector on which the infconvolution is evaluated
  //output: 0: no output, 1: progress bar
  // f = inf_y [f1(y) + f2(x-y)]
  // y = argmin_y [f1(y) + f2(x-y)]
  if argn(2)<8 then output=0;end;

  //reduces to ka using g=_zero and lambda=0.5 with a scaling by lambda
  //ka(f1,f2,0;lambda,lambda*x)=lambda * infconv(f1,f2)(x)
  lambda=0.5;  xt = lambda * x;
  [y,argmin] = opt_ka(f1,df1,domf1,f2,df2,domf2,_zero,_zero,[-%inf,%inf],xt,lambda,output);
  y = y/lambda;
  argmin = argmin / lambda;
endfunction