//Quick plot of one or two PLQ functions.
//x1,x5 can be finite or infinity values. 
function plq_plot(plqf1,plqf2,x1,x5),
    if (argn(2) < 2) then plqf2 = %f; end;
    if (argn(2) < 3 | x1 == -%inf) then x1 = -5; end;
    if (argn(2) < 4 | x5 == %inf) then x5 = 5; end;
    x=linspace(x1,x5,201)';
    //clf();
    y1=plq_eval(plqf1,x);
    if (~plqf2) then
      plot2d(x,y1);
    else
      y2=plq_eval(plqf2,x);
      plot2d(x,[y1,y2]);
    end;
    a=gca(); // Handle on axes entity
    a.thickness=3;
    if (plqf2) then
      poly1= a.children.children(1); //store polyline handle into poly1
      poly1.foreground = 6; // another way to change the style
      poly1.thickness = 4;
      poly1.line_style = 2;
    end;
endfunction