//Plot multiple PLQ functions.
//x1,x5 can be finite or infinity values. 
function plq_plotMultiple(x1,x5,varargin)
    if (argn(2) < 1 | x1 == %f | x1 == -%inf) then
      x1 = %inf;
      for i = 1:length(varargin)
        f = varargin(i);
        lb = max(1, min(find(f(:,4) ~= %inf)) - 1);
        x1 = min(x1, f(lb,1));
      end;
      if (isinf(x1)) then x1 = -5; end;
      spaceLeft = 1;
    else
      spaceLeft = 0;
    end;
    if (argn(2) < 2 | x5 == %f | x5 == %inf) then
      x5 = -%inf;
      for i = 1:length(varargin)
        f = varargin(i);
        ub = max(find(f(:,4) ~= %inf));
        x5 = max(x5, f(ub,1));
      end;
      if (isinf(x5)) then x5 = 5; end;
      spaceRight = 1;
    else
      spaceRight = 0;
    end;
    if (length(varargin) == 0) then return; end;
    spacing = (x5-x1) * 0.15;
    x = linspace(x1-spacing*spaceLeft, x5+spacing*spaceRight, 200)';
    y=[];
    // Todo: Plot indicator functions specially: plot2d(f(1,1), f(1,4), -5);
    for i = 1:length(varargin)
      f = varargin(i);
      y(:,i) = plq_eval(f, x);
    end;
    plot2d(x, y);
endfunction