function plq_plotpa_lambdaSet(plq0,plq1,x,lset,mu,rect)
  // Plot the graph of (x,lambda)->pa(f,lambda), but use plq_pa_mu which
  // supports the proximal average of non-convex functions.  Varies lambda
  // with a fixed mu.

  if size(x,2) >1 then x=x';end;
  if size(lset,1) >1 then lset=lset';end;
  th=1;
  clf();
  fig=gcf();
  
  drawlater();

  nc=max(round(length(lset)/100),100);//number of colors
  cm=[jetcolormap(nc)];
  fig.color_map = cm;
  colorbar(0,1);//h=gce();h.parent.font_size=4;

  i=1;stp=ceil(length(lset)/10);
  beginProgress();
  for lambda=lset,
    pa=plq_pa_mu(mu,lambda,plq0,plq1);
    y=plq_eval(pa,x);
    plot2d(x,y,style=ceil(lambda*nc)+1,rect=rect);//lambda no longer equispaced so cannot use style=i
    //if (i==1) then h=gca(); h.font_size=4; end;
    if modulo(i,stp)==0 then
    	  showProgress(i/length(lset));
    end;
    i=i+1;
  end;
  finishProgress();
  drawnow();
endfunction