function plq_plotpa_muSet(plq0,plq1,x,lambda,mus,rect)
  // Plot the graph of (x,lambda)->pa(f,lambda), but use plq_pa_mu which
  // supports the proximal average of non-convex functions.  Varies mu
  // with a fixed lambda.

  if size(x,2) >1 then x=x';end;
  if size(mus,1) >1 then mus=mus';end;
  clf(); 
  th=1;
  fig=gcf();
  drawlater();

  nc=max(round(length(mus)/100),100);//number of colors
  cm=[jetcolormap(nc)];
  fig.color_map = cm;
  //colorbar(0,1);  
  colorbar(0,max(mus));h=gce();h.parent.font_size=4;

  i=1;stp=ceil(length(mus)/10);
  beginProgress();
  for mu=mus,
    pa=plq_pa_mu(mu,lambda,plq0,plq1);
    y=plq_eval(pa,x);
    //the 2/%pi*atan() function sends [0,%inf] into [0,1] for plotting colors
    plot2d(x,y,style=ceil(2/%pi*atan(mu)*nc)+1,rect=rect);//lambda no longer equispaced so cannot use style=i
    if (i==1) then h=gca(); h.font_size=4; end;
    if modulo(i,stp)==0 then
      showProgress(i/length(mus));
    end;
    i=i+1;
  end;
  finishProgress();
  drawnow();
endfunction