//convert the subdifferential of a gph function into a piecewise-linear function
//error out if the graph of the subdifferential is not a function (it is always
//piecewise-linear but may have vertical pieces).
function q = pl_gph(G)
  eps=1e-8;
  x0 = G(1,1:$-1);x1 = G(1,2:$);
  if or(find(abs(x1-x0)<eps)) then q=[]; cerror("Unable to convert graph of subdifferential to piecewise-linear function: graph is not a function!");end;
  x = [G(1,2:$-1)';%inf];
  a = zeros(x);
  b = (G(2,2:$)-G(2,1:$-1))./(G(1,2:$)-G(1,1:$-1));//can't divide by zero here because of test above
  c = G(2,1:$-1)-b .* x0;
  q=[x a b' c'];
endfunction