function [b,er]=plq_check(p,ind)
  //check that p is a plq function
  //index: execute only specific tests (default: test all)
  //1: check x is increasing
  //2: check p is continuous
  //b: boolean true if tests are successful, false otherwise
  //er: maximum error found in the last test run.
  if argn(2)<2 then ind=[1 2];end;
  eps=1E-6;b=%t;er=0;
  if find(ind==1) then //check that x is increasing
    x=p(:,1);
    if x($)==%inf then x($)=[];end;
    dx=x(2:$)-x(1:$-1);er=min(dx);
    b = b & er>0;
  end
  if find(ind==2) then //check that p is continuous
    q=p;
    if p(1,4)==%inf then q(1,:)=[];end;//domain is left bounded
    if p($,4)==%inf then q($,:)=[];end;//domain is right bounded
    x=q(1:$-1,1);
    yleft  = q(1:$-1,2).*x.^2+q(1:$-1,3).*x+q(1:$-1,4);
    yright = q(2:$,2).*x.^2+q(2:$,3).*x+q(2:$,4);
    er = max(abs(yleft-yright));
    b = b & er < eps;
  end
endfunction