//////////PLQ CONJUGATE HELPER FUNCTION//////////////
function [plqClean] = plq_clean(plqDirty)  
  eps=1E-6;//1E-6;precision below which numbers are rounded to zero
  dplq=plqDirty(2:$-1,:)-plqDirty(1:$-2,:);
  //clear duplicate point values e.g [0,1,0,1;0,2,0,0] -> [0,1,0,1]
  j1=find(abs(dplq(:,1))<eps);//delete j1+1
  if length(j1)>0 then plqDirty(j1+1,:)=[];end;
  
  dplq=plqDirty(2:$,:)-plqDirty(1:$-1,:);
  //clear duplicate rows e.g. [0,1,0,0;0,1,0,0]->[0,1,0,0]
  if size(dplq,1)==1 then
    if norm(dplq(1,2:$))<eps then plqDirty(1,:)=[]; end;
  else    
    m=abs(dplq(:,2:$))*ones(3,1);
    n=abs(plqDirty(1:$-1,2:$))*ones(3,1);
    i=find(n==%inf | n==0);n(i)=1;//no division by %inf
    m=m./n;//use relative error
    j2=find(m<eps);plqDirty(j2,:)=[];    
  end
  //round small numbers to zero
  //this should be done by the clean function
  //but clean is buggy when the matrix contains %inf 
  //P1=plqDirty(:,2:$)
  P1=plqDirty
  P=matrix(P1,length(P1))
  ni=find(abs(P)<eps)
  P(ni)=0
  P1=matrix(P,size(P1))
  //plqDirty(:,2:$)=P1;
  plqDirty=P1;
  //Mike
  //Addition of infinity values results in functions like
  //  [x x x x]
  //  [x x x %inf]
  //  [x x x x%inf]
  //  [%inf x  x %inf]
  //However it is properly represented as
  //  [x x x x]
  //  [%inf x  x %inf]
  //The following lines of code remove the redundant infinity rows.

  plqInf = _plq_rowalwaysinf(plqDirty);
  [rs,cs] = find(and([plqInf(1:$-1,:), plqInf(2:$,:)], 'c'))
  if (size(rs,1) ~= 0) then
    plqDirty(rs+1,2:$-1) = 0;  // If rs==[], then rs+1==[1],
    plqDirty(rs,:) = [];       //  we want rs+1==[], hence the if.
  end
  //bounded domains are represented as x0,0,0,%inf so force the zeros in
  if (plqDirty(1,4)==%inf) then plqDirty(1,2:3)=0;end;
  //(same for xn,0,0,%inf)
  if (plqDirty($,4)==%inf) then plqDirty($,2:3)=0;end;
  plqClean = plqDirty;
endfunction
//////////PLQ CONJUGATE HELPER FUNCTION//////////////