function showProgress(percent, width, altstr)
  // [...] 100%
  // 1 2 345678
  global __ccaProgressWidth;
  global __ccaProgressWnd;
  if argn(2) < 2 then width = __ccaProgressWidth;
  elseif width == %f then width = __ccaProgressWidth;
  end;

  percent = min(percent, 1);

  if _progressType() == 1 then
    // GUI progress bar (via waitbar)
    if argn(2) < 3 then altstr = ""; end;
    if __ccaProgressWnd == [] then
      __ccaProgressWnd = waitbar(percent, altstr);
    else
      waitbar(percent, altstr, __ccaProgressWnd);
    end;
  else
    // CLI progress bar
    width = max(width, 8);
    barWidth = width - 7;
    starCnt = int(percent * barWidth);
    spaceCnt = barWidth - starCnt;
    printf("\r[");                     // '\r' is also code2str(113)
    for i = 1:starCnt; printf("*"); end;
    for i = 1:spaceCnt; printf("_"); end;
    printf("] %3d%%", int(percent*100));
    if argn(2) >= 3 then printf("  %s", altstr); end;
  end;
endfunction