function lst = _plqFunctions()
  //return a list of plq functions to be used
  //for unit testing
  lst=list();
  lst($+1)=[0 0 -1 0; %inf 0 1 0];//abs function
  lst($+1)=[-1 0 0 %inf;1 0 0 0 ;%inf 0 0 %inf];//I_[-1,1]
  // A piecewise linear function:
  //     x<0: y=-x
  //   0<x<1: y=0
  //     1<x: y=x-1
  lst($+1)=[0 0 -1 0;1 0 0 0;%inf 0 1 -1];
  // A PLQ function:
  //     x<-1: y=(x+1)^2
  //   -1<x<1: y=0
  //      1<x: y=(x-1)^2
  lst($+1)=[-1 1 2 1;1 0 0 0;%inf 1 -2 1];
  // A PLQ function:
  //   x in [-1,1]: 0
  //     otherwise: x^2 - 1
  lst($+1)=[-1 1 0 -1;1 0 0 0;%inf 1 0 -1];
  lst($+1)=[%inf,1,0,0];//x^2
  lst($+1)=[%inf,0,1,0];//x
  lst($+1)=[1,0,0,2];//I_{1}+2
  lst($+1)=[-1 0 0 %inf;1 0 1 0 ;%inf 0 0 %inf];//x+I_[-1,1]
  lst($+1)=[1 0 1 0 ;%inf 0 0 %inf];//x+I_[1,%inf)
  lst($+1)=[-1 0 0 %inf;1 0 1 0 ];//x+I_(-%inf,1]
  
endfunction

