mode(-1);

__test_set = "GPH: _gph_check";

function [b] = testBoundedDomain()
  f=[-1 -1 1 1;-1 0 0 1;%inf 0 0 %inf];
  b=_gph_check(f);
endfunction

function [b] = testXNondecreasing()
  f=[-1 -2 1 1;-1 0 0 1;0 0 0 0];
  b= ~_gph_check(f);
endfunction

function [b] = testSNondecreasing()
  f=[-1 0 1 1;-1 0 0 -1;0 0 0 0];
  b= ~_gph_check(f);
endfunction

function [b] = testN()
  f=[1;0;0];
  b=~_gph_check(f);//n==1
  f=[-1 -2 1 1;-1 0 0 1];
  b=b & ~_gph_check(f);//2xn
endfunction

function [b] = testFullDomain()
  p=[%inf,1,0,0];f=gph_plq(p);
  b=_gph_check(f);
endfunction

function [b] = testIndicatorSingleton()
  p=[1,0,0,2];f=gph_plq(p);
  b=_gph_check(f);
endfunction

function [b] = testCont()
  b = %f;
  f = [  -1 -1  0 0 1    1; ..
         -2 -1 -1 0 2    3; ..
       %inf  1  0 0 1 %inf];
  b = _gph_check(f);
endfunction

function [b] = testDiscont1()
  b = %f;
  f = [  -1 -1  0 0 1    1; ..
         -2 -1 -1 0 2    3; ..
       %inf  1  1 1 2 %inf];
  b = ~_gph_check(f);
endfunction

function [b] = testDiscont2()
  b = %f;
  f = [  -1 -1  0 0 1    1; ..
         -2 -1 -1 0 2    3; ..
       %inf  1  0 1 1 %inf];
  b = ~_gph_check(f);
endfunction

function [b] = testDiscont3()
  b = %f;
  f = [  -1 -1  0 0 1    1; ..
         -2 -1 -1 0 2    3; ..
       %inf  1  1 0 1 %inf];
  b = ~_gph_check(f);
endfunction

function [b] = testDiscontL()
  // Test discontinuity in the first region.
  b = %f;
  f = [-1  0 0 1; ..
       -1 -1 1 1; ..
        2  0 0 1];
  b = ~_gph_check(f);
endfunction

function [b] = testDiscontR()
  // Test discontinuity in the first region.
  b = %f;
  f = [-1  0 0 1; ..
       -1 -1 1 1; ..
        1  0 0 2];
  b = ~_gph_check(f);
endfunction

function [b] = runTestFile()
  b = %t;
  b = checkForFail(testWrapper(testBoundedDomain,"testBoundedDomain"), b);    
  b = checkForFail(testWrapper(testXNondecreasing,"testXNondecreasing"), b);    
  b = checkForFail(testWrapper(testSNondecreasing,"testSNondecreasing"), b);    
  b = checkForFail(testWrapper(testN,"testN"), b);    
  b = checkForFail(testWrapper(testFullDomain,"testFullDomain"), b);    
  b = checkForFail(testWrapper(testIndicatorSingleton,"testIndicatorSingleton"), b);    
  b = checkForFail(testWrapper(testCont,"testCont"), b);
  b = checkForFail(testWrapper(testDiscont1,"testDiscont1"), b);
  b = checkForFail(testWrapper(testDiscont2,"testDiscont2"), b);
  b = checkForFail(testWrapper(testDiscont3,"testDiscont3"), b);
  b = checkForFail(testWrapper(testDiscontL,"testDiscontL"), b);
  b = checkForFail(testWrapper(testDiscontR,"testDiscontR"), b);
endfunction
