mode(-1);

__test_set = "GPH: gph_isEqual";

function b = test1()
  //domain is split
  p1=[%inf 1 0 0];g1=gph_plq(p1);
  p2=[0 1 0 0;%inf 1 0 0];g2=gph_plq(p2);
  b=gph_isEqual(g1,g2);
  //small values
  eps=1e-9;
  p2=[%inf 1+eps eps -eps];g2=gph_plq(p2);
  b=b & gph_isEqual(g1,g2);
  //small values + split partitions
  p2=[-eps 1 0 eps;eps 1-eps -eps/10 0;%inf 1 -eps eps/1000];
  g2=gph_plq(p2);
  b=b & gph_isEqual(g1,g2);
endfunction

function b = testIndicator()
  p = [2,0,0,1];
  g = gph_plq(p);
  ge = [2 2;-1 1;1 1];
  b = gph_isEqual(g,ge);
endfunction

function b = testFullDomain()
  p = [2,0,0,1];
  g = gph_plq(p);
  ge = [2 2;-1 1;1 1];
  b = gph_isEqual(g,ge);
endfunction

function b= test2()
  p = [-1 -1 1 1; -1 0 0 1;%inf 0 0 %inf];  
  g = gph_plq(p);
  b = gph_isEqual(g,g);  
endfunction

function [b] = runTestFile()
	b = %t;
	b = checkForFail(testWrapper(test1,"test1"), b);	
    b = checkForFail(testWrapper(testIndicator,"testIndicator"), b);	
    b = checkForFail(testWrapper(testFullDomain,"testFullDomain"), b);		
    b = checkForFail(testWrapper(test2,"test2"), b);		    
endfunction
