// I = Indicator, E = Exponential, C = Conjugate, L = Linear, Q = Quadratic
mode(-1);
__test_set = "GPH: gph_pa";

function b=_test(f1,f2,lambda)
  rplq = plq_pa(f1,f2,lambda);
  G1=gph_plq(f1);G2=gph_plq(f2);
  G = gph_pa(G1,G2,lambda);
  rgph = plq_gph(G);
  b = plq_isEqual(rplq, rgph);
endfunction

function [b] = testL2Lpa()
  f1 = [%inf, 0, 1, 0];
  f2 = [%inf, 0, -1, 5]; 
  b = _test(f1,f2,0.5);
endfunction

function [b] = testI2Ipa()
  f1 = [6,0,0,4];
  f2 = [5,0,0,1];
  b = _test(f1,f2,0.5);  
endfunction

function b = testQ2Q()
	p0 = [%inf,0.5,0,0];
	p1 = [%inf,1,-2,1];
	b = _test(p0,p1,0.2);
endfunction

function [b] = testAbs2zero1a()
	f1 = [0,0,0,0];
	f2 = [0,0,-1,0;%inf,0,1,0];
	b = _test(f2,f1,0.5);
endfunction

function [b] = testAbs2zero1b()
	f1 = [0,0,0,0];
	f2 = [0,0,-1,0;%inf,0,1,0];
	b = _test(f1,f2,0.5);
endfunction

function b = testPLQ2PLQ()
  x=linspace(-2,2,4)';
  function y=f0(x),y=x.^4;endfunction
  function y=df0(x),y=4*x.^3;endfunction
  p0 = plq_build(x,f0,df0,%f,%f,'soqs','bounded');
  p1 = [%inf,1,-2,1];
  b = _test(p1,p0,0.5);
  b = _test(p0,p1,0.5);
endfunction

function [b] = testAbs2zero2a()
	f0 = [%inf,0,0,0];
	f1 = [0,0,-1,0;%inf,0,1,0];
	b = _test(f1,f0,0.5);
endfunction

function [b] = testAbs2zero2b()
	f0 = [%inf,0,0,0];
	f1 = [0,0,-1,0;%inf,0,1,0];
	b = _test(f0,f1,0.5);
endfunction

function b = test1()
  function y=f0(x), y=x.^4;endfunction
  function y=df0(x), y=4*x.^3;endfunction
  domf0=[-%inf,%inf];
  function y=f1(x), y=exp(x);endfunction
  function y=df1(x), y=exp(x);endfunction
  domf1=[-%inf,%inf];
  x=linspace(-10,10,5);
  p0 = plq_build(x,f0,df0,%f,%f,'soqs','bounded');
  p1 = plq_build(x,f1,df1,%f,%f,'soqs','bounded');  
  b = _test(p0,p1,0.5);
endfunction

function b= test2()
  f1=[-2,0,0,%inf;-1,0,0,0;%inf,0,0,%inf];
  f2=[1,0,0,%inf;2,0,0,0;%inf,0,0,%inf];
  b = _test(f1,f2,0.5);
endfunction

function [b] = runTestFile()
  b = %t;
  b = checkForFail(testWrapper(testL2Lpa, "testL2Lpa"), b);
  b = checkForFail(testWrapper(testI2Ipa, "testI2Ipa"), b);
  b = checkForFail(testWrapper(testAbs2zero1a, "testAbs2zero1a"), b);	//fails
  b = checkForFail(testWrapper(testAbs2zero1b, "testAbs2zero1b"), b);	//fails
  b = checkForFail(testWrapper(testQ2Q, "testQ2Q"), b);	
  b = checkForFail(testWrapper(testPLQ2PLQ, "testPLQ2PLQ"), b);	
  b = checkForFail(testWrapper(testAbs2zero2a, "testAbs2zero2a"), b);
  b = checkForFail(testWrapper(testAbs2zero2b, "testAbs2zero2b"), b);  //fails
  b = checkForFail(testWrapper(test1, "test1"), b);
  b = checkForFail(testWrapper(test2, "test2"), b);  
endfunction
