// Unit test file for _gph_plotbounds

mode(-1);

__test_set = "GPH: gph_plot utility functions";

function [b] = testPass1()
	fabs=[-1 0 0 1 ; -1 -1 1 1; 1 0 0 1 ];
	rect = _gph_plotbounds(list(fabs));	
	b = and(rect==[-1.2,-1.2,1.2,1.2]);
endfunction

function [b] = testPass2()
	fabs=[-1 0 0 1 ; -1 -1 1 1; 1 0 0 1 ];
	g=[-2 -1 -1 1 1 2; -1 -1 0 0 1 1; 1 0 0 0 0 1];
	rect = _gph_plotbounds(list(fabs,g));	
	b = and(rect==[-2.4,-1.2,2.4,1.2]);
endfunction

function [b] = testPass2a()
  h1=[-1 0 0 1; -2 -2 2 2;2 0 0 2];//2*abs
  h2=[-3 -2 -2 0 0 0.5;-1 -1 0 0 1 1;1 0 0 0 0 1];
	rect = _gph_plotbounds(list(h1,h2));	
	b = and(rect==[-3.4,-2.4,1.4,2.4]);
endfunction

function [b] = testPass1_gph_yCoord()
  y = _gph_yCoord(-2,0,-1,1,-1);//horizontal line
	b = (y == -1);
	y = _gph_yCoord(-2,0,-1,1,0);//angled line
	b = b & (y==-3);
	i=ieee();ieee(2);//vertical line
	y = _gph_yCoord(-1,0,0,0,1);
	ieee(i);
	b = b & (y==-%inf);
	y = _gph_yCoord(0,0,-1,1,0);//angled line
	b = b & (y==-1);	
endfunction

function [b] = testPass1_gph_extendGph()
  fabs=[-1 0 0 1 ; -1 -1 1 1; 1 0 0 1 ];
  rect = _gph_plotbounds(list(fabs));
  b=and(rect==[-1.2,-1.2,1.2,1.2]);
  G=_gph_extendGph(fabs,rect);
  b = b & and(G==[-1.2 -1 0 0 1 1.2;-1 -1 -1 1 1 1]);
endfunction

function [b] = testPass2_gph_extendGph()
  f=[-1 -1 1 1;-1 0 0 1;0 0 0 0];
  rect = _gph_plotbounds(list(f));
  b=and(rect==[-1.2,-1.2,1.2,1.2]);
  G=_gph_extendGph(f,rect);
  b = b & and(G==[-1 -1 -1 1 1 1;-1.2 -1 0 0 1 1.2]);
endfunction

//disable plotting
//function [b] = testPass_gph_plot()
//  fabs=[-1 0 0 1 ; -1 -1 1 1; 1 0 0 1 ];
//  while (winsid() ~= []); xdel(); end;
//  clf();gph_plot(fabs);
//  while (winsid() ~= []); xdel(); end;
//  return %t;
//endfunction


function [b] = runTestFile()
	b = %t;
  b = checkForFail(testWrapper(testPass1,"testPass1"), b);	
  b = checkForFail(testWrapper(testPass2,"testPass2"), b);	
  b = checkForFail(testWrapper(testPass2a,"testPass2a"), b);	
  b = checkForFail(testWrapper(testPass1_gph_yCoord,"testPass1_gph_yCoord"), b);	  
  b = checkForFail(testWrapper(testPass1_gph_extendGph,"testPass1_gph_extendGph"), b);
  b = checkForFail(testWrapper(testPass2_gph_extendGph,"testPass2_gph_extendGph"), b);
//  b = checkForFail(testWrapper(testPass_gph_plot,"testPass_gph_plot"), b);      
endfunction
