mode(-1);
__test_set = "OPT: opt_ic";

function b = test1()
  //inf-convolution of abs with x^2/2
  //i.e. Moreau envelope of abs
  function y=f1(x), y=abs(x);endfunction
  function y=df1(x),if x<0 then y=-1; else y=1;end;endfunction
  function y=f2(x),y=x.^2/2;endfunction
  function y=df2(x),y=x;endfunction

  x=linspace(-4,4,5)';
  [f,y]=opt_ic(f1,df1,[-%inf,%inf],f2,df2,[-%inf,%inf],x);
  p = [0,0,-1,0;%inf, 0, 1, 0];//abs
  q=plq_me(p,1);
  ff=plq_eval(q,x);
  b = and(abs(f-ff)<0.01);
endfunction

function b = test2()
  //inf-convolution of x^2/2 with x^2/2
  //i.e. Moreau envelope of x^2/2
  function y=f2(x),y=x.^2/2;endfunction
  function y=df2(x),y=x;endfunction
  f1=f2;df1=df2;
  x=linspace(-4,4,5)';
  [f,y]=opt_ic(f1,df1,[-%inf,%inf],f2,df2,[-%inf,%inf],x);
  p = [%inf, 0.5, 0, 0];//abs
  q=plq_me(p,1);
  ff=plq_eval(q,x);
  b = and(abs(f-ff)<0.01);
endfunction

function b = runTestFile()
	b = %t;
	b = checkForFail(testWrapper(test1, "test1"), b);
	b = checkForFail(testWrapper(test2, "test2"), b);
endfunction
