mode(-1);
__test_set = "OPT: opt_me";

function b = test0()
  f=_energy;df=_identity;

  x=linspace(-4,4,3)';
  [fopt,y]=opt_me(f,df,[-%inf,%inf],x,0.5);
  p1 = [%inf,0.5,0,0];
  q=plq_me(p1,0.5);
  ff=plq_eval(q,x);
  b = isEqual(fopt,ff);
endfunction

function b = test1()
  function y=f(x),y=x+1;endfunction
  function y=df(x),y=1;endfunction  

  x=linspace(-4,4,3)';
  [fopt,y]=opt_me(f,df,[-%inf,%inf],x,0.5);
  p1 = [%inf,0,1,1];
  q=plq_me(p1,0.5);
  ff=plq_eval(q,x);
  b = isEqual(fopt,ff);
endfunction

function b = test2()
  function y=f(x),if x<-1 | x>1 then y=%inf;else y=0;end;endfunction
  df=f;

  x=linspace(-4,4,3)';
  [fopt,y]=opt_me(f,df,[-1,1],x,1/2);
  p1 = [-1,0,0,%inf;1,0,0,0;%inf,0,0,%inf];
  q=plq_me(p1,1/2);
  ff=plq_eval(q,x);
  b = isEqual(fopt,ff);
endfunction

function b = runTestFile()
	b = %t;
	b = checkForFail(testWrapper(test0, "test0"), b);	
	b = checkForFail(testWrapper(test1, "test1"), b);	
	b = checkForFail(testWrapper(test2, "test2"), b);		
endfunction
