mode(-1);
__test_set = "OPT: opt_pa";

function b = test0()
  //prox-average of 0 with abs
  function y=f1(x),y=x.^2/2;endfunction
  function y=df1(x),y=x;endfunction
  function y=f2(x),y=x.^2/2;endfunction
  function y=df2(x),y=x;endfunction

  x=linspace(-4,4,3)';
  [f,y]=opt_pa(f1,df1,[-%inf,%inf],f2,df2,[-%inf,%inf],x,0.5);
  p1 = [%inf,0.5,0,0];
  p2 = p1;
  q=plq_pa(p1,p2,0.5);
  ff=plq_eval(q,x);
  b = isEqual(f,ff);
endfunction

function b = test1()
  //prox-average of x^2/2 with abs
  function y=f1(x),y=x.^2/2;endfunction
  function y=df1(x),y=x;endfunction
  function y=f2(x), y=abs(x);endfunction
  function y=df2(x),if x<0 then y=-1; else y=1;end;endfunction

  x=linspace(-4,4,3)';
  [f,y]=opt_pa(f1,df1,[-%inf,%inf],f2,df2,[-%inf,%inf],x,0.5);
  p1 = [%inf,0.5,0,0];
  p2 = [0,0,-1,0;%inf, 0, 1, 0];//abs
  q=plq_pa(p1,p2,0.5);
  ff=plq_eval(q,x);
  b = isEqual(f,ff);
endfunction

function b = test2()
  //prox-average of 0 with 0
  function y=f1(x),y=0;endfunction
  function y=df1(x),y=0;endfunction  
  f2=f1;df2=df1;
  x=linspace(-4,4,3)';
  [f,y]=opt_pa(f1,df1,[-%inf,%inf],f2,df2,[-%inf,%inf],x,0.5);
  p1 = [%inf,0,0,0];
  p2 = p1;
  q=plq_pa(p1,p2,0.5);
  ff=plq_eval(q,x);
  b = isEqual(f,ff);
endfunction

function b = test3()
  //prox-average of indicators
  function y=f1(x),if x>=-1 & x<=1 then y=0;else y=%inf;end;endfunction
  function y=df1(x),if x>=-1 & x<=1 then y=0;else y=%inf;end;endfunction
  f2=_energy;df2=_identity;
  x=linspace(-4,4,3)';
  [f,y]=opt_pa(f1,df1,[-1,1],f2,df2,[-%inf,%inf],x,0.5);
  p1 = [-1,0,0,%inf;1,0,0,0;%inf,0,0,%inf];
  p2 = [%inf,0.5,0,0];
  q=plq_pa(p1,p2,0.5);
  ff=plq_eval(q,x);
  b = isEqual(f,ff);
endfunction

function b = test4()
  //lambda=1
  //prox-average of x^2/2 with abs
  function y=f1(x),y=x.^2/2;endfunction
  function y=df1(x),y=x;endfunction
  function y=f2(x), y=abs(x);endfunction
  function y=df2(x),if x<0 then y=-1; else y=1;end;endfunction

  x=linspace(-4,4,5)';lambda=1;
  [f,y]=opt_pa(f1,df1,[-%inf,%inf],f2,df2,[-%inf,%inf],x,lambda);
  p1 = [%inf,0.5,0,0];
  p2 = [0,0,-1,0;%inf, 0, 1, 0];//abs
  q=plq_pa(p1,p2,lambda);
  ff=plq_eval(q,x);
  b = isEqual(f,ff);
endfunction

function b = test5()
  //lambda=0
  //prox-average of x^2/2 with abs
  function y=f1(x),y=x.^2/2;endfunction
  function y=df1(x),y=x;endfunction
  function y=f2(x), y=abs(x);endfunction
  function y=df2(x),if x<0 then y=-1; else y=1;end;endfunction

  x=linspace(-4,4,5)';lambda=0;
  [f,y]=opt_pa(f1,df1,[-%inf,%inf],f2,df2,[-%inf,%inf],x,lambda);
  p1 = [%inf,0.5,0,0];
  p2 = [0,0,-1,0;%inf, 0, 1, 0];//abs
  q=plq_pa(p1,p2,lambda);
  ff=plq_eval(q,x);
  b = isEqual(f,ff);
endfunction

function b = test6()
  //prox-average of x^2/2 with abs
  function y=f1(x),y=x.^2/2;endfunction
  function y=df1(x),y=x;endfunction
  function y=f2(x), y=abs(x);endfunction
  function y=df2(x),if x<0 then y=-1; else y=1;end;endfunction

  x=linspace(-4,4,5)';lambda=1/3;
  [f,y]=opt_pa(f1,df1,[-%inf,%inf],f2,df2,[-%inf,%inf],x,lambda);
  p1 = [%inf,0.5,0,0];
  p2 = [0,0,-1,0;%inf, 0, 1, 0];//abs
  q=plq_pa(p1,p2,lambda);
  ff=plq_eval(q,x);
  b = isEqual(f,ff);
endfunction

function b = test7()
  //prox-average of indicators
  function y=f1(x),if x>=-1 & x<=1 then y=0;else y=%inf;end;endfunction
  function y=df1(x),if x>=-1 & x<=1 then y=0;else y=%inf;end;endfunction
  function y=f2(x),if x>=0 & x<=2 then y=0;else y=%inf;end;endfunction
  function y=df2(x),if x>=0 & x<=2 then y=0;else y=%inf;end;endfunction
  x=linspace(-4,4,3)';
  [f,y]=opt_pa(f1,df1,[-1,1],f2,df2,[0,2],x,0.5);
  p1 = [-1,0,0,%inf;1,0,0,0;%inf,0,0,%inf];
  p2 = [0,0,0,%inf;2,0,0,0;%inf,0,0,%inf];
  q=plq_pa(p1,p2,0.5);
  ff=plq_eval(q,x);
  b = isEqual(f,ff);
endfunction

function b = runTestFile()
	b = %t;
	b = checkForFail(testWrapper(test0, "test0"), b);	
	b = checkForFail(testWrapper(test1, "test1"), b);
	b = checkForFail(testWrapper(test2, "test2"), b);
	b = checkForFail(testWrapper(test3, "test3"), b);	
	b = checkForFail(testWrapper(test4, "test4"), b);
	b = checkForFail(testWrapper(test5, "test5"), b);
	b = checkForFail(testWrapper(test6, "test6"), b);	
	b = checkForFail(testWrapper(test7, "test7"), b);		
endfunction
