// Author: 	    Mike Trienis
// Whatsit:         A wrapper function for various pl_me_generic envelope functions

mode(-1);
__test_set = "ME: Moreau - General Moreau Envelope";

function [b] = testMEllt_Wrapper_1d()
	b = %f;
	X = (1:10)';S = X;
	F=X.^2;
	desired = pl_me_llt(X, F, S);
	result = pl_me_generic(X, F, S);
	b = and(result == desired);
endfunction

function [b] = testMEdirect_Wrapper_1d()
	b = %f;
	X = (1:10)';S = X;
	F=X.^2;
	[Mr,pr,Pr] = pl_me_generic(X,F,S);
	[Md,pd,Pd] = pl_me_direct(X,F,S);
	b = and([Mr,pr,Pr] == [Md,pd,Pd]);
endfunction

function [b] = testMEllt_Wrapper_2d()
	b = %f;
	Xr = [1 2.2 3]'; Sr = Xr;
	Xc = [1 2 3]'; Sc = Xc;
	F = [3   100 100;100 100 100;100 100 2  ];
	desired_g = [ 2.50 52.92 55.00 ; 52.50 54.42 56.50 ; 55.00 56.92 10.00 ];
	[MYw,gw,Conjpartialw,Conjw] = pl_me_generic(Xr, Xc, F, Sr, Sc);
	[MY,g,Conjpartial,Conj] = pl_me_llt_2d(Xr, Xc, F, Sr, Sc);
	eps=1E-10;
	b = and(abs([MYw,gw,Conjpartialw,Conjw] - [MY,g,Conjpartial,Conj]) < eps);
endfunction

function testME_Wrapper_0()
  pl_me_generic();
endfunction

function testMeDirect2dWrongSize()
  Xr = 1:4; Xc = 1:5; f = eye(5, 5);
  Sr = 1:3; Sc = 2:5;
  pl_me_direct_2d(Xr, Xc, f, Sr, Sc);
endfunction

function testMeBrute2dWrongSize()
  Xr = 1:4; Xc = 1:5; f = eye(5, 5);
  Sr = 1:3; Sc = 2:5;
  pl_me_brute_2d(Xr, Xc, f, Sr, Sc);
endfunction

function [b] = runTestFile()
	b = %t;
	b = checkForFail(testWrapper(testMEllt_Wrapper_1d, "testMEllt_Wrapper_1d"), b);
	b = checkForFail(testWrapper(testMEdirect_Wrapper_1d, "testMEdirect_Wrapper_1d"), b);
	b = checkForFail(testWrapper(testMEllt_Wrapper_2d, "testMEllt_Wrapper_2d"), b);
	b = checkForFail(errorTestWrapper(testME_Wrapper_0, "testME_Wrapper_0"), b);
	b = checkForFail(errorTestWrapper(testMeDirect2dWrongSize, "testMeDirect2dWrongSize"), b);
	b = checkForFail(errorTestWrapper(testMeBrute2dWrongSize, "testMeBrute2dWrongSize"), b);
endfunction
