mode(-1);

__test_set = "PLQ: clrDuplicateRows";

function [b] = testDuplicatePoints()
	plqDirty=[0,1,0,0;0,2,0,0;1,2,3,4;%inf,3,0,0];
	plqClean=plq_clean(plqDirty);
	plqdesired = [0,1,0,0;1,2,3,4;%inf,3,0,0];
	b = and(plqdesired==plqClean);
endfunction

function [b] = testDuplicateRows()
	plqDirty=[0,1,0,0;0,1,0,0;1,2,3,4;%inf,3,0,0];
	plqClean=plq_clean(plqDirty);
	plqdesired = [0,1,0,0;1,2,3,4;%inf,3,0,0];
	b = and(plqdesired==plqClean);
endfunction

function [b] = testDuplicatePoints2()
	plqDirty=[-1,1,2,3;0,1,0,0;0,2,0,0;1,2,3,4;2,4,5,6;%inf,3,0,0];
	plqClean=plq_clean(plqDirty);
	plqdesired = [-1,1,2,3;0,1,0,0;1,2,3,4;2,4,5,6;%inf,3,0,0];
	b = and(plqdesired==plqClean);
endfunction

function [b] = testDuplicateRows2()
	plqDirty=[-1,1,2,3;0,1,0,0;0,1,0,0;1,2,3,4;2,3,4,5;%inf,3,0,0];
	plqClean=plq_clean(plqDirty);
	plqdesired = [-1,1,2,3;0,1,0,0;1,2,3,4;2,3,4,5;%inf,3,0,0,];
	b = and(plqdesired==plqClean);
endfunction

function [b] = testDuplicateEnd()
	plqDirty=[-1,1,2,3;0,1,0,0;0,1,0,0;0,2,0,0;1,2,3,4;2,3,4,5;%inf,3,4,5];
	plqClean=plq_clean(plqDirty);
	plqdesired = [-1,1,2,3;0,1,0,0;1,2,3,4;%inf,3,4,5];
	b = and(plqdesired==plqClean);
endfunction

function [b] = testQuadratic()
  x=linspace(-2,2)';x($)=%inf;
	plqDirty=[x,ones(x),zeros(x),zeros(x)];
	plqClean=plq_clean(plqDirty);
	plqdesired = [%inf,1,0,0,];
	b = and(plqdesired==plqClean);
endfunction

function [b] = testLinear()
  x=linspace(-2,2)';function y=f(x), if abs(x)<=1 then y=0; else y=abs(x)-1;end;endfunction
  function y=df(x), if abs(x)<=1 then y=0; else y=sign(x);end;endfunction
	plqDirty=plq_build(x,f,df,%t);
	plqClean=plq_clean(plqDirty);
	plqdesired = [-1,0,-1,-1;1,0,0,0;%inf,0,1,-1,];
	b = and(plqdesired==plqClean);
endfunction


function [b] = testDuplicateFunctions()
	b = %f;
	plqfstarDirty = [0,0,0,0; 1,1,1,1; 2,1,1,1; 3,2,2,2];
	result = plq_clean(plqfstarDirty)
	desired = [0, 0, 0, 0;2,1,1,1;3,2,2,2];         
	b = and(result==desired);
endfunction

function [b] = testDuplicateDomains()
	b = %f;
	plqfstarDirty = [0,0,0,0; 1,1,1,1; 1,2,3,4; 3,2,2,2];
	result = plq_clean(plqfstarDirty)
	desired = [0, 0, 0, 0;1,1,1,1;3,2,2,2];         
	b = and(result==desired);
endfunction

function [b] = testDuplicateDomsAndFns()
	b = %f;
	plqfstarDirty = [0,0,0,0; 1,13,13,13; 1,7,7,7; 2,7,7,7; 3,2,2,2];
	result = plq_clean(plqfstarDirty)
	desired = [0,0,0,0;1,13,13,13;2,7,7,7;3,2,2,2];         
	b = and(result==desired);
endfunction

function [b] = testRound2Zero()
	b = %f;
	plqfstarDirty = [1E-15,0,0,0; 1,13,1E-14,13; 2,1E-12,7,7; 3,2,2,1E-10];
	result = plq_clean(plqfstarDirty)
	desired = [0,0,0,0;1,13,0,13;2,0,7,7;3,2,2,0];         
	b = and(result==desired);
endfunction

function [b] = runTestFile()
	b = %t;
	b = checkForFail(testWrapper(testDuplicatePoints, "testDuplicatePoints"), b);
	b = checkForFail(testWrapper(testDuplicateRows, "testDuplicateRows"), b);
	b = checkForFail(testWrapper(testDuplicatePoints2, "testDuplicatePoints2"), b);
	b = checkForFail(testWrapper(testDuplicateRows2, "testDuplicateRows2"), b);
	b = checkForFail(testWrapper(testDuplicateEnd, "testDuplicateEnd"), b);
	b = checkForFail(testWrapper(testDuplicatePoints, "testDuplicatePoints"), b);
	b = checkForFail(testWrapper(testQuadratic, "testQuadratic"), b);
	b = checkForFail(testWrapper(testLinear, "testLinear"), b);
	b = checkForFail(testWrapper(testDuplicateFunctions,"testDuplicateFunctions"), b);
	b = checkForFail(testWrapper(testDuplicateDomains,"testDuplicateDomains"), b);
	b = checkForFail(testWrapper(testDuplicateDomsAndFns,"testDuplicateDomsAndFns"), b);
endfunction


