// Test-script for plq_eval (Yves Lucet - 2006-06-21)
//

__test_set = "PLQ: plq_eval - Evaluate PLQ Function";
mode(-1);

global m0;compi=1;
clear Temps;

// unit tests ==========================================================
function [b] = testXinsidex()
	X=[1;2;4;5;7;8;9];
	plqf=[3,0.5,0,0;6,0,0,0;%inf,0,1,0];
	[y,k] = plq_eval(plqf,X);
	
	b = isequal(k, [1,2,3;1,3,5;2,4,7])
	b = checkForFail(isequal(y, [0.5;2;0;0;7;8;9]), b);
endfunction

function [b] = testXemptybeforex()
	X=[4;5;7;8;9];
	plqf=[3,0.5,0,0;6,0,0,0;%inf,0,1,0];
	[y,k] = plq_eval(plqf,X);
	b = isequal(k, [2,3; 1,3;2,5])
	b = checkForFail(isequal(y, [0;0;7;8;9]), b);
endfunction

function [b] = testXallbeforex()
	X=[4;5;7;8;9];
	plqf=[10,0.5,0,0;15,0,0,0;%inf,0,1,0];
	[y,k] = plq_eval(plqf,X);
	b = isequal(k, [1;1;5])
	b = checkForFail(isequal(y, [8;12.5;24.5;32;40.5]), b);
endfunction

function [b] = testXalllastx()
	X=[4;5;7;8;9];
	plqf=[-2,0.5,0,0;1,0,0,0;%inf,0,1,0];
	[y,k] = plq_eval(plqf,X);
	b = isequal(k, [3;1;5])
	b = checkForFail(isequal(y, [4;5;7;8;9]), b);
endfunction

function [b] = testIndicator()
	X=(-5:5)';
	plqf=[0,0,0,1];
	y = plq_eval(plqf,X);
	yy=%inf*ones(X);
	yy(6)=1;
	b = isequal(y, yy)
endfunction

function testNonInfRightBound()
  plqf = [-5,1,3,2; 6,-2,-1,4];
  plq_eval(plqf, 1);
endfunction

function [b] = runTestFile()
  b = %t;
  b = checkForFail(testWrapper(testXinsidex, "testXinsidex"), b);
  b = checkForFail(testWrapper(testXemptybeforex, "testXemptybeforex"), b);
  b = checkForFail(testWrapper(testXallbeforex, "testXallbeforex"), b);
  b = checkForFail(testWrapper(testXalllastx, "testXalllastx"), b);
  b = checkForFail(testWrapper(testIndicator, "testIndicator"), b);
  b = checkForFail(errorTestWrapper(testNonInfRightBound, "testNonInfRightBound"), b);
endfunction
