// I = Indicator, E = Exponential, C = Conjugate, L = Linear, Q = Quadratic
mode(-1);
__test_set = "PLQ: plq_gpa";

function [b] = testAbs()
  p0=[0,0,-1,0;%inf,0,1,0];p1=p0;
  p =plq_gpa(p0,p1,0.5,1);
  q = [-0.2 0 -1 -0.1;0.2 2.5 0 0;%inf,0,1,-0.1];
  b = plq_isEqual(p,q);
endfunction

function [b] = testZero()
  p0=[%inf,0,0,0];p1=p0;
  p =plq_gpa(p0,p1,0.5,1);
  q = [%inf,0,0,0];
  b = plq_isEqual(p,q);
endfunction

function [b] = testX()
  p0=[%inf,1,0,0];p1=p0;
  p =plq_gpa(p0,p1,0.5,1);
  q = [%inf,0.714285714,0,0];
  b = plq_isEqual(p,q);  
endfunction

function [b] = testL2I()
  p0=[%inf,0,0,0];p1=[0,0,0,0];
  p =plq_gpa(p0,p1,0.5,1);
  q = [%inf,0.416666666666,0,0];
  b = plq_isEqual(p,q);    
endfunction

function [b] = testL2Q()
  p0=[%inf,0,0,0];p1=[%inf,0.5,0,0];
  p =plq_gpa(p0,p1,0.5,1);
  q = [%inf,0.15625,0,0];
  b = plq_isEqual(p,q);    
endfunction

function [b] = runTestFile()
	b = %t;
	b = checkForFail(testWrapper(testAbs, "testAbs"), b);
	b = checkForFail(testWrapper(testZero, "testZero"), b);
	b = checkForFail(testWrapper(testX, "testX"), b);	
	b = checkForFail(testWrapper(testL2I, "testL2I"), b);	
  b = checkForFail(testWrapper(testL2Q, "testL2Q"), b);
endfunction
