mode(-1);
__test_set = "PLQ: plq_isConvex";

function b = testAbs()
	//abs function
  p = [0,0,-1,0;%inf,0,1,0];  
  b = plq_isConvex(p);
endfunction

function b = testQuartic()
  function y=f(x), y=x.^4;endfunction
  function dy=df(x), dy=4*x.^3;endfunction
  x=linspace(-2,2,4)';
  
  p=plq_build(x,f,df,%t,%f,'soqs','bounded');
  b = plq_isConvex(p);
endfunction
 

function [b] = testInd()
	// The function I_[-1,1].
  p = [-1,0,0,%inf; 1,0,0,0; %inf,0,0,%inf];
  b = plq_isConvex(p);
endfunction

function [b] = testPL()
	// A "\_/" function.
  p = [0,0,-1,0; 1,0,0,0; %inf,0,1,-1];
  b = plq_isConvex(p);
endfunction

function [b] = testPLQ1()
	b = %f;
	// A PLQ function:
	//     x<-1: y=(x+1)^2
	//   -1<x<1: y=0
	//      1<x: y=(x-1)^2
  p = [-1,1,2,1; 1,0,0,0; %inf,1,-2,1];
  b = plq_isConvex(p);
endfunction

function b = testPLQ2()
	// A PLQ function:
	//   x in [-1,1]: 0
	//     otherwise: x^2 - 1
  p = [-1,1,0,-1; 1,0,0,0; %inf,1,0,-1];
  b = plq_isConvex(p);
endfunction

function b = testFullDomain()
  p = [%inf,1,0,0];
  b = plq_isConvex(p);
endfunction

function b = testIndicator()
  p = [2,0,0,1];
  b = plq_isConvex(p);
endfunction


function [b] = runTestFile()
          b = %t;
          b = checkForFail(testWrapper(testAbs,"testAbs"), b);
          b = checkForFail(testWrapper(testQuartic,"testQuartic"), b);          
          b = checkForFail(testWrapper(testInd,"testInd"), b);
          b = checkForFail(testWrapper(testPL,"testPL"), b);
          b = checkForFail(testWrapper(testPLQ1,"testPLQ1"), b);
          b = checkForFail(testWrapper(testPLQ2,"testPLQ2"), b);
          b = checkForFail(testWrapper(testFullDomain,"testFullDomain"), b);
          b = checkForFail(testWrapper(testIndicator,"testIndicator"), b);          
endfunction
