mode(-1);

__test_set = "PLQ: plq_me - Moreau Envelope";

function [b] = testMELineWrapper()
	b = %f;
	lambda=1;
	fctn = [%inf,0,1,1];
	result = plq_me(fctn,lambda)
	desired = [%inf, 0, 1, 1/2]         
	b = and(result==desired);
endfunction

function [b] = testMEQuadraticWrapper()
	b = %f;
	lambda=1;
	fctn = [%inf,1/2,0,0];
	result = plq_me(fctn,lambda)
	desired = [%inf, 1/4, 0, 0];         
	b = and(result==desired);
endfunction

function [b] = testMEIndicatorWrapper()
	b = %f;
	lambda = 1;
	plqf = [5,0,0,1];
	result = plq_me(plqf,lambda);
	desired = [%inf,0.5,- 5, 13.5];
	b = and(result==desired);
endfunction

function [b] = testMEnonconvex()
	b = %f;
	lambda = 1;plqf=[-1,0,-1,-1;0,0,1,1;1,0,-1,1;%inf,0,1,-1];
	result = plq_me(plqf,lambda,%f);
	desired = [-2,0,-1,-1.5;0,0.5,1,0.5;2,0.5,-1,0.5;%inf,0,1,-1.5];
	b = (result==desired);
endfunction

function [b] = testMaxScale1()
  b = %f;
  f = [0,-1,0,0;%inf,-2,0,0];
  desired = -1/2/(-2);
  result = plq_me_max_scale(f);
  b = isEqual(desired, result);
endfunction

function [b] = testMaxScale2()
  b = %f;
  f = [0,1,0,0;%inf,0,1,0];
  desired = %inf;
  result = plq_me_max_scale(f);
  b = isEqual(desired, result);
endfunction

function [b] = testMaxScale3()
  b = %f;
  f1 = [0,-1,0,0;%inf,-2,0,0];
  f2 = [1,0,1,0;2,0,-1,2;%inf,-3,0,0];
  m1 = plq_me_max_scale(f1);
  m2 = plq_me_max_scale(f2);
  m = plq_me_max_scale(f1, f2);
  b = (isEqual(m, 1/6) & m == min(m1, m2));
endfunction

function [b] = runTestFile()
	b = %t;
	b = checkForFail(testWrapper(testMELineWrapper,"testMELineWrapper"), b);
	b = checkForFail(testWrapper(testMEIndicatorWrapper,"testMEIndicatorWrapper"), b);
	b = checkForFail(testWrapper(testMEQuadraticWrapper,"testMEQuadraticWrapper"), b);
	b = checkForFail(testWrapper(testMEnonconvex,"testMEnonconvex"), b);
	b = checkForFail(testWrapper(testMaxScale1,"testMaxScale1"), b);
	b = checkForFail(testWrapper(testMaxScale2,"testMaxScale2"), b);
endfunction
