// Author:   Mike Trienis
// For:      Dr. Yves Lucet
// Whatsit:  A test file for plq_max, adds two piecewise linear quadratic functions. 

mode(-1);
//L: Linear, Q: Quadratic, I: Indicator, PW: Piecewise

__test_set = "PLQ: plq_max - Maximum of two plq functions f and g";
clear testQLMax testQLQMax testQQMax testQQMaxdl

function [b] = testLLMin()
	b = %f;	
	plqf = [%inf,0,1,0];
	plqg = [%inf,0,-1,0];
	[result,maxf] = plq_min(plqf,plqg);
//	x=linspace(-5,5,25)';
//	ymax = plq_eval(result,x);
//  plot2d(x,ymax);
	desired = [0,0,1,0;%inf,0,-1,0];          
	b = and(result==desired);
	b = b & maxf == [1,-%inf,0;2,0,%inf];
endfunction

function [b] = testQLMax()
	b = %f;	
	plqf = [%inf,1,0,0];
	plqg = [%inf,0,0,1];
	result = plq_min(plqf,plqg);
//	x=linspace(-5,5,25)';
//	ymax = plq_eval(result,x);
//  plot2d(x,ymax);
	desired = [-1,1,0,0;1,0,0,1;%inf,1,0,0];         
	b = and(result==desired);
endfunction

function [b] = testQLQMax()
	b = %f;
	plqf = [-1,1,0,0;1,0,0,1;%inf,1,0,0];
	plqg = [0,1,0,0;2,0,1,0;%inf,1,0,-2];
	result = plq_min(plqf,plqg,1);
  result_clean = plq_clean(result);
//	x=linspace(-5,5,100)';
//	yf = plq_eval(plqf,x);
//	yg = plq_eval(plqg,x);
// plot2d(x,[yf,yg],rect=[-2,-1,2,5]);
  desired = [-1,1,0,0;1,0,0,1;%inf,1,0,0]; 
	b = and(result_clean==desired);
endfunction

function [b] = testQQMax()
	b = %f;
	plqf1 = [%inf,1,0,0];
	plqf2 = [%inf,1/10,0,1];
	result = plq_min(plqf1,plqf2);
//	x=linspace(-5,5,100)';
//  f0=plq_eval(result,x);
//  f1=plq_eval(plqf1,x);
//  f2=plq_eval(plqf2,x);
//  plot2d(x,[f0,f1,f2]);
//  a=gca(); // Handle on axes entity
//  a.thickness=3;
//  poly1= a.children.children(3); //store polyline handle into poly1
//  poly1.foreground = 2; // another way to change the style
//  poly1.thickness = 3;
  desired = [- 1.0540926,1,0,0;1.0540926,0.1,0,1;%inf,1,0,0]; 
	b = and(result(:,2:$)==desired(:,2:$));
endfunction

function [b] = testQQMaxdl()
	b = %f;
	plqf1 = [%inf,1,0,0];
	plqf2 = [%inf,1,2,-1];
	result = plq_min(plqf1,plqf2);
//	x=linspace(-5,5,100)';
//  f0=plq_eval(result,x);
//  f1=plq_eval(plqf1,x);
//  f2=plq_eval(plqf2,x);
//  plot2d(x,[f0,f1,f2]);
//  a=gca(); // Handle on axes entity
//  a.thickness=3;
//  poly1= a.children.children(3); //store polyline handle into poly1
//  poly1.foreground = 2; // another way to change the style
//  poly1.thickness = 3;
  desired = [0.5,1,0,0;%inf,1,2,-1]; 
	b = and(result==desired);
endfunction

//Graphical Test
//function [b] = testExpMaxQ()
//  b = %f;
//  x=linspace(0,5,50)';
//  
//  plqf1 = plq_build(x,exp,exp); 
//  //plqf2 = [%inf,1,0,2];  
//  plqf2 = [%inf,1,0,2];
//  result = plq_min(plqf1,plqf2,1);
//  
//  f0=plq_eval(result,x);
//  f1=plq_eval(plqf1,x);
//  f2=plq_eval(plqf2,x);
//  
//  plot2d(x,[f0,f1,f2],rect=[0,0,2.5,10]);
//  
//  a=gca(); // Handle on axes entity
//  a.thickness=3;
//  poly1= a.children.children(3); //store polyline handle into poly1
//  poly1.foreground = 2; // another way to change the style
//  poly1.thickness = 3; 
//  //
// 
//endfunction

//Graphical Test
//function [b] = testSinMaxZero()
//  b = %f;
//  x=linspace(0,15,150)';
//  
//  plqf1 = plq_build(x,sin,cos); //ROW 13, ROW 14 (Non-increasing x values) BUG! --or f must be convex
//  //plqf2 = [%inf,1,0,2];  
//  plqf2 = [%inf,0,0,0];
//  result = plq_min(plqf1,plqf2,1);
//  
//  f0=plq_eval(result,x);
//  f1=plq_eval(plqf1,x);
//  f2=plq_eval(plqf2,x);
//  
//  plot2d(x,[f0,f1,f2]);
//  
//  a=gca(); // Handle on axes entity
//  a.thickness=3;
//  poly1= a.children.children(3); //store polyline handle into poly1
//  poly1.foreground = 2; // another way to change the style
//  poly1.thickness = 3; 
//  //
// 
//endfunction

//TODO More tests for plq_max
//TODO Code plq_minx
//TODO Code Addition function again!

function [b] = runTestFile()
	b = %t;
	b = checkForFail(testWrapper(testLLMin,"testLLMin"), b);
endfunction
