// I = Indicator, E = Exponential, C = Conjugate, L = Linear, Q = Quadratic
mode(-1);
__test_set = "PLQ: plq_pa";

function b = testL2Lpa()
	lambda_pa = 0.5;
	f1 = [%inf, 0, 1, 0];
	f2 = [%inf, 0, -1, 5]; 
	desired = [%inf,0,0,2];
	result = plq_pa(f1,f2,lambda_pa),
	result2 = plq_pa_mu(1,lambda_pa,f1,f2),
	b = isEqual(desired, result, result2),
endfunction

function b = testI2Ipa()
	lambda_pa = 0.5;
	f2 = [5,0,0,1];
	f1 = [6,0,0,4];
	desired = [5.5,0,0,2.625];
	result = plq_pa(f1,f2,lambda_pa);
	//2 lines below fail after modifying plq_scalar.
	//Need to investigate (later)
	result2 = plq_pa_mu(1,lambda_pa,f1,f2);
	b = isEqual(desired, result, result2);
	b = isEqual(desired, result);
endfunction

function b = testAbs2zero()
	lambda_pa = 1;
	f0 = [0,0,0,0];
	f1 = [0,0,-1,0;%inf,0,1,0];
	r = plq_pa(f0,f1,lambda_pa);
	rp= plq_pa_mu(1,lambda_pa,f0,f1);
	b = isEqual(f1,r, rp);
endfunction

function b = testL2L()
	lambda_pa = 0.5;
	f0 = [%inf,0,-1,0];
	f1 = [%inf,0,1,0];
	r = plq_pa(f0,f1,lambda_pa);
	rp= plq_pa_mu(1,0.5,f0,f1);
	b = isEqual([%inf,0,0,-0.5], r, rp);
endfunction

function b = testAbs2zero2()
	lambda_pa = 0.5;
	f0 = [%inf,0,0,0];
	f1 = [0,0,-1,0;%inf,0,1,0];
	r = plq_pa(f0,f1,lambda_pa);
	rp= plq_pa_mu(1,lambda_pa,f0,f1);
	b = isEqual(r, rp);
endfunction

function b = testPaNc()
	lambda_pa = 1;
	f0 = [0,0,-1,0;%inf,0,1,0];	//abs
	f1 = plq_scalar(f0,-1);//-abs
	r = plq_pa(f0,f1,lambda_pa,%f);
	rp= plq_pa_mu(1,lambda_pa,f0,f1);
	//since f1 + r x^2 is NOT convex, the pa is NOT equal to f1
	b = isEqual(r, rp);
endfunction

function b = runTestFile()
	b = %t;
	b = checkForFail(testWrapper(testL2Lpa, "testL2Lpa"), b);
	b = checkForFail(testWrapper(testI2Ipa, "testI2Ipa"), b);
	b = checkForFail(testWrapper(testAbs2zero, "testAbs2zero"), b);	
	b = checkForFail(testWrapper(testL2L, "testL2L"), b);	
  b = checkForFail(testWrapper(testAbs2zero2, "testAbs2zero2"), b);
  b = checkForFail(testWrapper(testPaNc, "testPaNc"), b);
endfunction
