// Author: Bryan Gardiner
// For: Yves Lucet
// Date: Summer 2008
// Test %inf-order Fitzpatrick functions.

// <-- NO CHECK REF -->

printf("Testing with a linear operator.\n");
a = 1:3;
astar = a/2 + 4;
A = [a;astar];
B = [a;astar;astar];
x = 0:1;
xstar = 0:1;
dresult = op_fitz_brute(A, %inf, x, xstar);
rresult = op_fitz_direct(A, %inf, x, xstar);
lresult = op_fitz(A, %inf, x, xstar);
iresult = op_fitzinf(B, x, xstar);
if (~isEqual(dresult, rresult)) then pause; end;
if (~isEqual(dresult, lresult)) then pause; end;

printf("Testing with a horizontal segment.\n");
astar = [1,2,2,3,3];
a = 1:length(astar);
A1 = [a;astar];
A2 = [a;astar;astar];
x = 0:5;
xstar = 0:5;
// desired was computed with op_fitz_brute.
desired = [-1,0,1,4,9,14; 0,1,2,5,10,15; 1,2,4,7,12,17; 3,4,6,9,14,19; 5,6,8,12,17,22; 8,9,11,15,20,25];
rresult = op_fitz_direct(A1, %inf, x, xstar);
//lresult = op_fitz(A1, n, x, xstar);        LLT can't handle duplicate a values.
iresult = op_fitzinf(A2, x, xstar);
if (~and(abs(desired - rresult) < 1E-5)) then pause; end;
if (~and(abs(desired - iresult) < 1E-5)) then pause; end;

printf("Testing op_fitzinf with nonincreasing a values.\n");
b = %t;
try
	a  = [1,2,2,3];
	bl = [1,3,5,7];
	br = [2,4,6,8];
	A = [a;bl;br];
	x = 0;
	xstar = 0;
	op_fitzinf(A, x, xstar);
catch
	disp(lasterror(%f));
	if (lasterror() == "op_fitzinf: a values are not strictly increasing.")
		b = %f;
	end
end
if b then pause; end;
