// Author: 	    Mike Trienis
// Whatsit:         A wrapper function for various pl_me_generic envelope functions

// <-- NO CHECK REF -->

printf("testMEllt_Wrapper_1d\n");
X = (1:10)';S = X;
F=X.^2;
desired = pl_me_llt(X, F, S);
result = pl_me_generic(X, F, S);
if (~and(result == desired)) then pause; end;

printf("testMEdirect_Wrapper_1d\n");
X = (1:10)';S = X;
F=X.^2;
[Mr,pr,Pr] = pl_me_generic(X,F,S);
[Md,pd,Pd] = pl_me_direct(X,F,S);
if (~and([Mr,pr,Pr] == [Md,pd,Pd])) then pause; end;

printf("testMEllt_Wrapper_2d\n");
Xr = [1 2.2 3]'; Sr = Xr;
Xc = [1 2 3]'; Sc = Xc;
F = [3   100 100;100 100 100;100 100 2  ];
desired_g = [ 2.50 52.92 55.00 ; 52.50 54.42 56.50 ; 55.00 56.92 10.00 ];
[MYw,gw,Conjpartialw,Conjw] = pl_me_generic(Xr, Xc, F, Sr, Sc);
[MY,g,Conjpartial,Conj] = pl_me_llt_2d(Xr, Xc, F, Sr, Sc);
eps=1E-10;
if (~and(abs([MYw,gw,Conjpartialw,Conjw] - [MY,g,Conjpartial,Conj]) < eps)) then pause; end;

printf("testME_Wrapper_0\n");
b = %t;
try
	pl_me_generic();
catch
	if (lasterror() == 'pl_me_generic: Incorrect calling sequence.')
		b = %f;
	end
end
if b then pause; end;

printf("testMeDirect2dWrongSize\n");
b = %t;
try
	Xr = 1:4; Xc = 1:5; f = eye(5, 5);
	Sr = 1:3; Sc = 2:5;
	pl_me_direct_2d(Xr, Xc, f, Sr, Sc);
catch
	if (lasterror() == 'Inconsistent size of f in pl_me_direct_2d. size(Xr)=4, but size(f,1)=5');
		b = %f;
	end
end
if b then pause; end;

printf("testMeBrute2dWrongSize\n");
b = %t;
try
	Xr = 1:4; Xc = 1:5; f = eye(5, 5);
	Sr = 1:3; Sc = 2:5;
	pl_me_brute_2d(Xr, Xc, f, Sr, Sc);
catch
	if (lasterror() == 'Inconsistent size of f in pl_me_brute_2d. size(Xr)=4, but size(f,1)=5');
		b = %f;
	end
end
if b then pause; end;
