// Author:   Mike Trienis
// For:      Dr. Yves Lucet
// Whatsit:  A test file for plq_add, adds two piecewise linear quadratic functions. 
//L: Linear, Q: Quadratic, I: Indicator, PW: Piecewise

// <-- NO CHECK REF -->

printf("testQLQNonsmPlusQLQNonsm\n");
plqf = [-1,1,0,0;1,0,0,1;%inf,1,0,0];
plqg = [0,1,0,0;2,0,1,0;%inf,1,0,-2];
result=plq_add(plqf,plqg);
desired = [-1,2,0,0;0,1,0,1;1,0,1,1;2,1,1,0;%inf,2,0,-2];          
if (~and(result==desired)) then pause; end;

printf("testQQSmoothPlusQQSmooth\n");
plqf = [-1,1,1,1; %inf,1,1,1];
plqg = [-2,1,1,0; %inf,1,1,0];
result = plq_add(plqf,plqg);
desired = [%inf,2,2,1];          
if (~and(result==desired)) then pause; end;

printf("testQLSmoothPlusQLQNonsm\n");
//Note this function tests when there is a common point between the two PLQ functions
plqf=[1,1,0,0;3, 0, 2, -1;%inf,3,-16,26];
plqg=[0,1,0,0;1, 0, 1, 0;%inf,3, -4, 2];
result = plq_add(plqf,plqg);
desired = [0,2,0,0;1,1,1,0;3,3,-2,1;%inf,6,-20,28];          
if (~and(result==desired)) then pause; end;

printf("testIPlusQ\n");
plqf=[4,0,0,5];
plqg=[%inf,1/2,0,0];
result = plq_add(plqf,plqg);
desired = [4,0,0,13];          
if (~and(result==desired)) then pause; end;

printf("testIPlusQPW\n");
plqf=[4,0,0,5];
plqg=[0,0,-1,0;%inf,0,1,0];
result = plq_add(plqf,plqg);
desired = [4,0,0,9];          
if (~and(result==desired)) then pause; end;

printf("testIPlusQPW2\n");
plqg=[4,0,0,5];
plqf=[0,0,-1,0;%inf,0,1,0];
result = plq_add(plqf,plqg);
desired = [4,0,0,9];          
if (~and(result==desired)) then pause; end;

printf("testIPlusPL\n");
Ii=[-0.5,0,0,%inf;0.5,0,0,0;%inf,0,0,%inf];
plq=[-1,0,-1,-1;0,0,1,1;1,0,-1,1;%inf,0,1,-1];
result = plq_add(Ii,plq);
desired = [-0.5,0,0,%inf;0,0,1,1;0.5,0,-1,1;%inf,0,0,%inf];
if (~and(result==desired)) then pause; end;

printf("testIPlusI\n");
f1 = [1,0,0,3];
f2 = [1,0,0,10];
result = plq_add(f1, f2);
desired = [1,0,0,13];
if (~isEqual(desired, result)) then pause; end;

printf("testIPlusI2\n");
f1 = [1,0,0,3];
f2 = [2,0,0,10];
result = plq_add(f1, f2);
desired = [%inf,0,0,%inf];
if (~isEqual(desired, result)) then pause; end;
