// Author:   Mike Trienis
// For:      Dr. Yves Lucet
// Whatsit:  A test file for plq convex hull functions plq_co and _plq_conv_on_interval

// I = Indicator, E = Exponential, C = Conjugate, L = Linear, Q = Quadratic

// <-- NO CHECK REF -->

printf("testQ2Lch_1\n");
plqf = [0,1,0,0;3,0,0,0];
f1 = plqf(1,:);
f2 = plqf(2,:);
x1=-2.5;
x3=f1(1,1);
x5=f2(1,1);
result = _plq_conv_on_interval(f1,f2,x1,x3,x5);
desired = plqf;          
if ~and(abs(result-desired) < 1E-5) then pause; end;

printf("testL2Qch_2\n");
plqf = [-1,0,0,1;3,1,0,0];
f1 = plqf(1,:);
f2 = plqf(2,:);
x1=-2.5;
x3=f1(1,1);
x5=f2(1,1);
result = _plq_conv_on_interval(f1,f2,x1,x3,x5);
desired = [-0.2087122,0,-0.4174243,-0.0435608;3,1,0,0];          
if ~and(abs(result-desired) < 1E-5) then pause; end;

printf("testL2Qch_3\n");
plqf = [0,0,0,0;2,-1,0,0];
f1 = plqf(1,:);
f2 = plqf(2,:);
x1=-2;
x3=f1(1,1);
x5=f2(1,1);
result = _plq_conv_on_interval(f1,f2,x1,x3,x5);
desired =[2,0,-1,-2];         
if ~and(abs(result-desired) < 1E-5) then pause; end;

printf("testQ2Lch_3\n");
plqf = [1,1,0,0;4,0,0,1]; 
f1 = plqf(1,:);
f2 = plqf(2,:);
x1=-2.5;
x3=f1(1,1);
x5=f2(1,1);
result = _plq_conv_on_interval(f1,f2,x1,x3,x5);
desired = [0.1270167,1,0,0;4,0,0.2540333,-0.0161332];          
if ~and(abs(result-desired) < 1E-5) then pause; end;

printf("testQ2Lch_4\n");
plqf = [1,-1,0,1;3,0,0,0];
f1 = plqf(1,:);
f2 = plqf(2,:);
x1=-2;
x3=f1(1,1);
x5=f2(1,1);
result = _plq_conv_on_interval(f1,f2,x1,x3,x5);
desired = [3,0,0.6,-1.8];  
if ~and(abs(result-desired) < 1E-5) then pause; end;

printf("testQ2Lch_5\n");
// This test was added to test the x(1)==-%inf & x(5)==%inf &
// a(1)<>0 & a(2)==0 case of _plq_conv_buildl.
// _plq_conv_on_interval:
// a(1) >= 0, a(2) >= 0
// a(1) <> 0, a(2) == 0
// a(1) > 0, a(2) == 0
// _conv_interval_func:
// (a(1) == 0 | x(5) == %inf) & (a(2) == 0 | x(1) <> -%inf)
// x(5) == %inf, a(2) == 0
// _plq_conv_buildl:
// a(1) > 0, a(2) == 0
// x(1) == -%inf, x(5) == %inf
plqf = [0,1,1,0;%inf,0,0,0];
result = _plq_conv_on_interval(plqf(1,:), plqf(2,:), -%inf, 0, %inf);
result($,1)=0;
desired = [-0.5,1,1,0;0,0,0,-0.25];
if ~and(norm(result-desired) < 1E-5) then pause; end;

printf("testQ2Qch_1\n");
plqf = [3/2,1,0,0;3,1,-4,6];
f1 = plqf(1,:);
f2 = plqf(2,:);
x1=-2.5;
x3=f1(1,1);
x5=f2(1,1);
result = _plq_conv_on_interval(f1,f2,x1,x3,x5);
desired=[0.5,1,0,0;2.5,0,1,-0.25;3,1,-4,6];         
if ~and(abs(result-desired) < 1E-5) then pause; end;

printf("testQ2Qch_2\n");
plqf = [0,1,1,2;5,1,-1,2];
f1 = plqf(1,:);
f2 = plqf(2,:);
x1=-2.5;
x3=f1(1,1);
x5=f2(1,1);
result = _plq_conv_on_interval(f1,f2,x1,x3,x5);
desired=[-0.5,1,1,2;0.5,0,0,1.75;5,1,-1,2];      
if ~and(abs(result-desired) < 1E-5) then pause; end;

printf("testQ2Qch_3\n");
plqf = [0,2,4,0;2,2,-4,0];
f1 = plqf(1,:);
f2 = plqf(2,:);
x1=-2;
x3=f1(1,1);
x5=f2(1,1);
result = _plq_conv_on_interval(f1,f2,x1,x3,x5);
desired =[-1,2,4,0;1,0,0,-2;2,2,-4,0];       
if ~and(abs(result-desired) < 1E-5) then pause; end;

printf("testQ2Qch_4\n");
plqf = [1,-1,0,2;5,1,-4,4];
f1 = plqf(1,:);
f2 = plqf(2,:);
x1=-2;
x3=f1(1,1);
x5=f2(1,1);
result = _plq_conv_on_interval(f1,f2,x1,x3,x5);
desired=[2.2426407,0,0.4852814,-1.0294373;5,1,-4,4];        
if ~and(abs(result-desired) < 1E-5) then pause; end;

printf("testQ2Qch_5\n");
plqf = [0,-1,-4,0;2,-1,4,0];
f1 = plqf(1,:);
f2 = plqf(2,:);
x1=-2;
x3=f1(1,1);
x5=f2(1,1);
result = _plq_conv_on_interval(f1,f2,x1,x3,x5);
desired=[0,0,-2,0;2,0,2,0];       
if ~and(abs(result-desired) < 1E-5) then pause; end;

printf("testQ2Qch_6\n");
plqf = [0,2,4,0;%inf,2,-4,0];
result = plq_co(plqf); result($,1)=0;
desired=[-1,2,4,0;1,0,0,- 2;%inf,2,-4,0]; desired($,1)=0;
if ~and(norm(result-desired) < 1E-5) then pause; end;

printf("testQ2Qch_7\n");
// This test was added to test the x(1)==-%inf & x(5)==%inf &
// a(1)<>0 & a(2)==0 case of _plq_conv_buildl.
// _plq_conv_on_interval:
// a(1) <> 0, a(2) <> 0
// _conv_interval_func:
// (a(1) == 0 | x(5) == %inf) & (a(2) == 0 | x(1) <> -%inf)
// x(5) == %inf, a(2) == 0
// _plq_conv_buildl:
// a(1) <> 0, a(2) <> 0
plqf = [0,2,1,0;%inf,1,0,0];
result = _plq_conv_on_interval(plqf(1,:), plqf(2,:), -%inf, 0, %inf);
desired = [-0.1464466,2,1,0;0.2071068,0,0.4142136,-0.0428932;%inf,1,0,0];
if ~isEqual(result, desired) then pause; end;

printf("testL2L2Qch_7\n");
plqf = [0,0,1,0;2,0,0,0;%inf,1,-4,4];
result = plq_co(plqf); result($,1)=0;
desired  = [2.5,0,1,-2.25;%inf,1,-4,4];  desired($,1)=0;
if ~and(norm(result-desired) < 1E-5) then pause; end;

printf("testQ2Q2Qch_8\n");
plqf =[-2,1,8,16;2,-1,0,8;%inf,1,-8,16]; 
result = plq_co(plqf); result($,1)=0;
desired  = [-4,1,8,16;4,0,0,0;%inf,1,-8, 16]; desired($,1)=0; 
if ~and(norm(result-desired) < 1E-5) then pause; end;

printf("testQ2Q2Qch_9\n");
plqf =[-2,1,8,16;2,-1,0,8;%inf,1,-8,16]; 
result = plq_co(plqf); result($,1)=0;
desired=[-4,1,8,16;4,0,0,0;%inf,1,-8,16]; desired($,1)=0;   
if ~and(norm(result-desired) < 1E-5) then pause; end;

printf("testQ2L2L2Qch_10\n");
plqf =[-3,1,8,16;0,0,1,4;3,0,-1,4;%inf,1,-8,16]; 
result = plq_co(plqf); result($,1)=0;
desired =  [-4,1,8,16;4,0,0,0;%inf,1,-8,16];  desired($,1)=0; 
if ~and(norm(result-desired) < 1E-5) then pause; end;

printf("testQ2L2L2Qch_11\n");
plqf =[-3,1,8,16;0,0,-1,-2;3,0,1,-2;%inf,1,-8,16]; 
result = plq_co(plqf); result($,1)=0;
desired = [-4.2426407,1,8,16;0,0,-0.4852814,-2;4.2426407,0,0.4852814,-2;%inf,1,-8,16]; desired($,1)=0; 
if ~and(norm(result-desired) < 1E-5) then pause; end;

printf("testL2Q2Lch_12\n");
plqf =[-2,0,-1,10;2,1,0,8;%inf,0,1,10];  
result = plq_co(plqf); result($,1)=0;
desired=[-0.5,0,-1,7.75;0.5,1,0,8;%inf,0,1,7.75];  desired($,1)=0;     
if ~and(norm(result-desired) < 1E-5) then pause; end;

printf("testL2Q2Lch_13\n");
plqf =[-2,0,-1,2;1,-1,0,8;%inf,0,1,6]; 
result = plq_co(plqf); result($,1)=0;
desired=[- 2,0,-1,2;%inf,0,1,6]; desired($,1)=0; 
if ~and(norm(result-desired) < 1E-5) then pause; end;

printf("testNegInfHull_1\n");
plqf = [0,-1,-2,1;1,0,0,1;%inf,1,1,0];
result = plq_co(plqf);
desired = [%inf,0,0,-%inf];
if ~and(result == desired) then pause; end;

printf("testNegInfHull_2\n");
plqf = [-1,1,4,3;1,0,2.5,2.5;3,1,-2,6;%inf,-2,12,-9];
result = plq_co(plqf);
desired = [%inf,0,0,-%inf];
if ~and(result == desired) then pause; end;

printf("testNegInfHull_3\n");
plqf = [0,0,-1,0;1,1,0,0;%inf,0,-2,3];
result = plq_co(plqf);
desired = [%inf,0,0,-%inf];
if ~and(result == desired) then pause; end;
