// Author:   Yves Lucet
// For:      Dr. Yves Lucet
// Whatsit:  A test file for clrDuplicateRows, helper function for plq_lft

// <-- NO CHECK REF -->

printf("testDuplicatePoints\n");
plqDirty=[0,1,0,0;0,2,0,0;1,2,3,4;%inf,3,0,0];
plqClean=plq_clean(plqDirty);
plqdesired = [0,1,0,0;1,2,3,4;%inf,3,0,0];
if ~and(plqdesired==plqClean) then pause; end;

printf("testDuplicateRows\n");
plqDirty=[0,1,0,0;0,1,0,0;1,2,3,4;%inf,3,0,0];
plqClean=plq_clean(plqDirty);
plqdesired = [0,1,0,0;1,2,3,4;%inf,3,0,0];
if ~and(plqdesired==plqClean) then pause; end;

printf("testDuplicatePoints2\n");
plqDirty=[-1,1,2,3;0,1,0,0;0,2,0,0;1,2,3,4;2,4,5,6;%inf,3,0,0];
plqClean=plq_clean(plqDirty);
plqdesired = [-1,1,2,3;0,1,0,0;1,2,3,4;2,4,5,6;%inf,3,0,0];
if ~and(plqdesired==plqClean) then pause; end;

printf("testDuplicateRows2\n");
plqDirty=[-1,1,2,3;0,1,0,0;0,1,0,0;1,2,3,4;2,3,4,5;%inf,3,0,0];
plqClean=plq_clean(plqDirty);
plqdesired = [-1,1,2,3;0,1,0,0;1,2,3,4;2,3,4,5;%inf,3,0,0,];
if ~and(plqdesired==plqClean) then pause; end;

printf("testDuplicateEnd\n");
plqDirty=[-1,1,2,3;0,1,0,0;0,1,0,0;0,2,0,0;1,2,3,4;2,3,4,5;%inf,3,4,5];
plqClean=plq_clean(plqDirty);
plqdesired = [-1,1,2,3;0,1,0,0;1,2,3,4;%inf,3,4,5];
if ~and(plqdesired==plqClean) then pause; end;

printf("testQuadratic\n");
x=linspace(-2,2)';x($)=%inf;
plqDirty=[x,ones(x),zeros(x),zeros(x)];
plqClean=plq_clean(plqDirty);
plqdesired = [%inf,1,0,0,];
if ~and(plqdesired==plqClean) then pause; end;

printf("testLinear\n");
x=linspace(-2,2)';function y=f(x), if abs(x)<=1 then y=0; else y=abs(x)-1;end;endfunction
function y=df(x), if abs(x)<=1 then y=0; else y=sign(x);end;endfunction
plqDirty=plq_build(x,f,df,%t);
plqClean=plq_clean(plqDirty);
plqdesired = [-1,0,-1,-1;1,0,0,0;%inf,0,1,-1,];
if ~and(plqdesired==plqClean) then pause; end;

printf("testDuplicateFunctions\n");
plqfstarDirty = [0,0,0,0; 1,1,1,1; 2,1,1,1; 3,2,2,2];
result = plq_clean(plqfstarDirty)
desired = [0, 0, 0, 0;2,1,1,1;3,2,2,2];         
if ~and(result==desired) then pause; end;

printf("testDuplicateDomains\n");
plqfstarDirty = [0,0,0,0; 1,1,1,1; 1,2,3,4; 3,2,2,2];
result = plq_clean(plqfstarDirty)
desired = [0, 0, 0, 0;1,1,1,1;3,2,2,2];         
if ~and(result==desired) then pause; end;

printf("testDuplicateDomsAndFns\n");
plqfstarDirty = [0,0,0,0; 1,13,13,13; 1,7,7,7; 2,7,7,7; 3,2,2,2];
result = plq_clean(plqfstarDirty)
desired = [0,0,0,0;1,13,13,13;2,7,7,7;3,2,2,2];         
if ~and(result==desired) then pause; end;

printf("testRound2Zero\n");
plqfstarDirty = [1E-15,0,0,0; 1,13,1E-14,13; 2,1E-12,7,7; 3,2,2,1E-10];
result = plq_clean(plqfstarDirty)
desired = [0,0,0,0;1,13,0,13;2,0,7,7;3,2,2,0];         
if ~and(result==desired) then pause; end;
