// Author:   Mike Trienis
// For:      Dr. Yves Lucet
// Whatsit:  A test file for plq

//L: Linear, Q: Quadratic, I: Indicator

// <-- NO CHECK REF -->

function plqf = plq_pl_from(x0, y0, dx, ms)
  if (size(ms, 1) > size(ms, 2)) then ms = ms'; end;
  plqf = zeros(length(ms) + 2, 4);
  x = x0;
  y = y0;
  plqf(1,:) = [x0, 0, 0, %inf];
  i = 2;
  for m = ms
    //if (%t | m < 0 & grand(1,'uin',0,1) == 1) then y = y - grand(1,1,'unf',0,10); end;
    //if (%t | m > 0 & grand(1,'uin',0,1) == 1) then y = y + grand(1,1,'unf',0,10); end;
    plqf(i,:) = [x + dx, 0, m, y - m*x];
    x = x + dx;
    y = plqf(i,3)*x + plqf(i,4);
    i = i + 1;
  end;
  plqf($,:) = [%inf, 0, 0, %inf];
  //[z, order] = gsort(plqf(:,1), 'r', 'i');
  //for i = 2:size(plqf,1)-2
  //  x = plqf(i,1);
  //  d = plqf(i,2)*x^2 + plqf(i,3)*x + plqf(i,4) - (plqf(i+1,2)*x^2 + plqf(i+1,3)*x + plqf(i+1,4));
  //  if (abs(d) > 1e-10) then
  //    disp(plqf);
  //    cerror(sprintf("plq_build2 error, pieces %d, %d, diff %f.", i, i+1, d));
  //    return;
  //  end;
  //end;
  //plqf = plqf(order,:);
endfunction

printf("testInfconvLft\n");
plqf = [%inf,1/4,0,0];
plqg = [%inf,1,0,0];
result = plq_infconv_lft(plqf,plqg);
desired = [%inf,1/5,0,0];
if ~and(result==desired) then pause; end;

printf("testDeconvLft\n");
plqf = [%inf,1/4,0,0];
plqg = [%inf,1,0,0];
result = plq_deconv_lft(plqf,plqg);
desired = [%inf,1/3,0,0];
if ~and(result==desired) then pause; end;

printf("testInfconvBruteDL1\n");
f = [-1,0,0,%inf;1,0,-1,0;%inf,0,0,%inf];
g = [-1,0,0,%inf;1,0,1,0;%inf,0,0,%inf];
desired = plq_infconv_lft(f, g);
[result1, lb1] = plq_infconv_brute_d(f(2,:), g(2,:), [-1;-1], [1;1]);
[result2, lb2] = plq_infconv_brute_d(g(2,:), f(2,:), [-1;-1], [1;1]);
result1 = [lb1,0,0,%inf;result1;%inf,0,0,%inf];
result2 = [lb2,0,0,%inf;result2;%inf,0,0,%inf];
if ~isEqual(desired, result1, result2) then pause; end;

printf("testInfconvBruteDL2\n");
f = [-0.5,0,0,%inf;1.5,0,-1,0.5;%inf,0,0,%inf];
g = [-1,0,0,%inf;1,0,1,0;%inf,0,0,%inf];
desired = plq_infconv_lft(f, g);
[result1, lb1] = plq_infconv_brute_d(f(2,:), g(2,:), [-0.5;-1], [1.5;1]);
[result2, lb2] = plq_infconv_brute_d(g(2,:), f(2,:), [-1;-0.5], [1;1.5]);
result1 = [lb1,0,0,%inf;result1;%inf,0,0,%inf];
result2 = [lb2,0,0,%inf;result2;%inf,0,0,%inf];
if ~isEqual(desired, result1, result2) then pause; end;

printf("testInfconvBruteDL3\n");
f = [-1,0,0,%inf;1,0,-1,0;%inf,0,0,%inf];
g = [2,0,0,%inf;4,0,1,-3;%inf,0,0,%inf];
desired = plq_infconv_lft(f, g);
[result1, lb1] = plq_infconv_brute_d(f(2,:), g(2,:), [-1;2], [1;4]);
[result2, lb2] = plq_infconv_brute_d(g(2,:), f(2,:), [2;-1], [4;1]);
result1 = [lb1,0,0,%inf;result1;%inf,0,0,%inf];
result2 = [lb2,0,0,%inf;result2;%inf,0,0,%inf];
if ~isEqual(desired, result1, result2) then pause; end;

printf("testInfconvBruteL0\n");
// nf==1, ng==1, f up, g up.
b = %f;
f = [-1,0,0,%inf;1,0,1,0;%inf,0,0,%inf];
g = [0,0,0,%inf;2,0,2,-1/2;%inf,0,0,%inf];
desired = plq_infconv_lft(f, g);
[result1, am1] = plq_infconv_brute(f, g);
[result2, am2] = plq_infconv_brute(g, f);
if ~isEqual(desired, result1, result2) then pause; end;
//if ~isEqual(am1, am2) then pause; end;

printf("testInfconvBruteL1\n");
// nf==2, ng==1, f v, g up.
b = %f;
f = [-1,0,0,%inf;1,0,-1,0;3,0,1,-2;%inf,0,0,%inf];
g = [-1,0,0,%inf;1,0,1,0;%inf,0,0,%inf];
desired = plq_infconv_lft(f, g);
[result1, am1] = plq_infconv_brute(f, g);
[result2, am2] = plq_infconv_brute(g, f);
if ~isEqual(desired, result1, result2) then pause; end;
//if ~isEqual(am1, am2) then pause; end;

printf("testInfconvBruteL2\n");
// nf==2, ng==2, f v, g v.
b = %f;
f = [-1,0,0,%inf;1,0,-1,0;3,0,1,-2;%inf,0,0,%inf];
g = [-3,0,0,%inf;-1,0,-1,-1;1,0,1,1;%inf,0,0,%inf];
desired = plq_infconv_lft(f, g);
[result1, am1] = plq_infconv_brute(f, g);
[result2, am2] = plq_infconv_brute(g, f);
if ~isEqual(desired, result1, result2) then pause; end;
//if ~isEqual(am1, am2) then pause; end;

printf("testInfconvBruteL3\n");
// nf==3, ng==3, f u, g down, disjoint domains.
b = %f;
f = [-4,0,0,%inf;-3,0,-1,-2;-2,0,0,1;-1,0,1,3;%inf,0,0,%inf];
g = [0,0,0,%inf;1,0,-5,8;2,0,-2,5;3,0,-1/2,2;%inf,0,0,%inf];
desired = plq_infconv_lft(f, g);
[result1,am1] = plq_infconv_brute(f, g);
[result2,am2] = plq_infconv_brute(g, f);
if ~isEqual(desired, result1, result2) then pause; end;
//if ~isEqual(am1, am2) then pause; end;

printf("testInfconvBruteL4\n");
//f = [0,0,0,%inf;2,0,0,1;3,0,0,0;6,0,0,1;%inf,0,0,%inf];
f = [0.5,0,0,%inf;1.5,0,-1,1.5;2.5,0,0,0;5,0,0.4,-1;%inf,0,0,%inf];
g = [0,0,0,%inf;1,0,-1,2;3,0,1,0;%inf,0,0,%inf];
desired = plq_infconv_lft(f, g);
[result1, am1] = plq_infconv_brute(f, g);
[result2, am2] = plq_infconv_brute(g, f);
if ~isEqual(desired, result1, result2) then pause; end;
//if ~isEqual(am1, am2) then pause; end;

printf("testInfconvBruteLCommut1\n");
f = plq_pl_from(0, 0, 1, 1:4);
g = plq_pl_from(0.1, -2, 0.3, 1:8);
desired = plq_infconv_lft(f, g);
[result1, am1] = plq_infconv_brute(f, g);
[result2, am2] = plq_infconv_brute(g, f);
if ~isEqual(desired, result1, result2) then pause; end;
//if ~isEqual(am1, am2) then pause; end;
