// Test-script for plq_eval (Yves Lucet - 2006-06-21)

// <-- NO CHECK REF -->

printf("testXinsidex\n");
X=[1;2;4;5;7;8;9];
plqf=[3,0.5,0,0;6,0,0,0;%inf,0,1,0];
[y,k] = plq_eval(plqf,X);
if ~isequal(k, [1,2,3;1,3,5;2,4,7]) then pause; end;
if ~isequal(y, [0.5;2;0;0;7;8;9]) then pause; end;

printf("testXemptybeforex\n");
X=[4;5;7;8;9];
plqf=[3,0.5,0,0;6,0,0,0;%inf,0,1,0];
[y,k] = plq_eval(plqf,X);
if ~isequal(k, [2,3; 1,3;2,5]) then pause; end;
if ~isequal(y, [0;0;7;8;9]), b) then pause; end;

printf("testXallbeforex\n");
X=[4;5;7;8;9];
plqf=[10,0.5,0,0;15,0,0,0;%inf,0,1,0];
[y,k] = plq_eval(plqf,X);
if ~isequal(k, [1;1;5]) then pause; end;
if ~isequal(y, [8;12.5;24.5;32;40.5]) then pause; end;

printf("testXalllastx\n");
X=[4;5;7;8;9];
plqf=[-2,0.5,0,0;1,0,0,0;%inf,0,1,0];
[y,k] = plq_eval(plqf,X);
if ~isequal(k, [3;1;5]) then pause; end;
if ~isequal(y, [4;5;7;8;9]) then pause; end;

printf("testIndicator\n");
X=(-5:5)';
plqf=[0,0,0,1];
y = plq_eval(plqf,X);
yy=%inf*ones(X);
yy(6)=1;
if ~isequal(y, yy) then pause; end;

printf("testNonInfRightBound\n");
b = %t;
plqf = [-5,1,3,2; 6,-2,-1,4];
try
	plq_eval(plqf, 1);
catch
	if lasterror() == 'Error in plq_eval: right bound of plqf should be infinity instead of 6'
		b = %f;
	end
end
