// Author: Bryan Gardiner
// For: Yves Lucet
// Date: Summer 2008
// Test PLQ Fitzpatrick function algorithms.

// <-- NO CHECK REF -->

printf("Testing plq_fitzinf0* and plq_rock with a nonmonotone operator.\n");
a = [1,2,3,4];
astar = [3,5,4,2];
B = [a;astar;astar+0.5];
F0 = [%inf,0,0,%inf];
F1 = plq_fitzinf0(B);
F2 = plq_fitzinf0_direct(B);
F3 = plq_rock(B, 1);
if (~and(isEqual(F0, F1))) then pause; end;
if (~and(isEqual(F0, F2))) then pause; end;
if (~and(isEqual(F0, F3))) then pause; end;

printf("Testing plq_fitzinf0 with nonincreasing a values.\n");
b = %t;
try
	a  = [1,2,2,3];
	bl = [1,3,5,7];
	br = [2,4,6,8];
	B = [a;bl;br];
	plq_fitzinf0(B);
catch
	disp(lasterror(%f));
	if (lasterror() == "op_fitzinf0: a values are not strictly increasing.")
		b = %f;
	end
end
if b then pause; end;

printf("Testing plq_fitzinf0_direct with nonincreasing a values.\n");
b = %t;
try
	a  = [1,2,2,3];
	bl = [1,3,5,7];
	br = [2,4,6,8];
	B = [a;bl;br];
	plq_fitzinf0_direct(B);
catch
	disp(lasterror(%f));
	if (lasterror() == "op_fitzinf0_direct: a values are not strictly increasing.")
		b = %f;
	end
end
if b then pause; end;
