// Author:   Mike Trienis
// For:      Dr. Yves Lucet
// Whatsit:  A test file for plq

//L: Linear, Q: Quadratic, I: Indicator

// <-- NO CHECK REF -->

printf("testLLNonsmooth\n");
plqf = [ -1, 0, -1, -1; %inf, 0, 1, 1];
result = plq_lft(plqf);
result2 = mikeplq_lft(plqf);
desired = [-1, 0, 0, %inf; 1, 0, -1, 0; %inf, 0, 0, %inf];          
if ~and(result==desired) then pause; end;
if ~and(result2==desired) then pause; end;

printf("testQQSmooth\n");
plqf = [-2,1,1,1;%inf,1,1,1];
result= plq_lft(plqf);
result2 = mikeplq_lft(plqf);
//desired = [-3, 1/4, -1/2, -3/4; %inf, 1/4, -1/2, -3/4];  
desired = [%inf, 1/4, -1/2, -3/4];
if ~and(result==desired) then pause; end;
if ~and(result2==desired) then pause; end;

printf("testQQQSmooth\n");
plqf = [-2,1,1,1;2,1,1,1;%inf,1,1,1];
result= plq_lft(plqf);
result2 = mikeplq_lft(plqf);
//desired = [-3, 1/4, -1/2, -3/4; 5, 1/4, -1/2, -3/4; %inf,1/4,-1/2,-3/4];
desired = [%inf,1/4,-1/2,-3/4];
if ~and(result==desired) then pause; end;
if ~and(result2==desired) then pause; end;

printf("testabs\n");
plqf = [0,0,-1,0;%inf,0,1,0];//abs
result= plq_lft(plqf);
result2 = mikeplq_lft(plqf);
desired = [-1, 0, 0, %inf; 1, 0, 0, 0; %inf, 0, 0, %inf];          
if ~and(result==desired) then pause; end;
if ~and(result2==desired) then pause; end;

printf("testL\n");
plqf=[%inf,0,1,1];
result= plq_lft(plqf);
result2 = mikeplq_lft(plqf);
desired = [1, 0, 0, -1];          
if ~and(result==desired) then pause; end;
if ~and(result2==desired) then pause; end;

printf("testI\n");
plqf=[1,0,0,-1];
result= plq_lft(plqf);
result2 = mikeplq_lft(plqf);
desired = [%inf, 0, 1, 1];          
if ~and(result==desired) then pause; end;
if ~and(result2==desired) then pause; end;

printf("testI2\n");
plqf=[1,0,0,-1];
result= plq_lft(plqf);
result2 = mikeplq_lft(plqf);
desired = [%inf, 0, 1, 1];          
if ~and(result==desired) then pause; end;
if ~and(result2==desired) then pause; end;

printf("testNormSquared\n");
plqf=[%inf,1/2,0,0];
result= plq_lft(plqf);
result2 = mikeplq_lft(plqf);
desired = [%inf, 1/2, 0, 0];          
if ~and(result==desired) then pause; end;
if ~and(result2==desired) then pause; end;

printf("testQQNonsmooth\n");
plqf=[0,1,0,0;%inf,2,0,0];
result= plq_lft(plqf);
result2 = mikeplq_lft(plqf);
desired = [0 , 1/4, 0, 0; %inf, 1/8, 0, 0];          
if ~and(result==desired) then pause; end;
if ~and(result2==desired) then pause; end;

printf("testQLQSmooth\n");
plqf=[1,1,0,0;3, 0, 2, -1;%inf,3,-16,26];
result= plq_lft(plqf);
result2 = mikeplq_lft(plqf);
s=result(:,1);sa=result(:,2);sb=result(:,3);sc=result(:,4);
resultLHS = [s];
result2LHS = result2(:,1);
desiredLHS = [2; %inf];
resultRHS = [sa, sb, sc];
result2RHS = result2(:,2:4);
desiredRHS =[1/4, 0, 0; 1/12, 8/3, -14/3];
if ~and((resultLHS==desiredLHS) & (norm(resultRHS - desiredRHS)<1E-8)) then pause; end;

printf("testQLQNonsmooth\n");
plqf=[0,1,0,0;1, 0, 1, 0;%inf,3, -4, 2];
result= plq_lft(plqf);
result2 = mikeplq_lft(plqf);
s=result(:,1);sa=result(:,2);sb=result(:,3);sc=result(:,4);
resultLHS = [s];
result2LHS = result2(:,1);
desiredLHS = [0; 1; 2; %inf];
resultRHS = [sa, sb, sc];
result2RHS = result(:,2:4);
desiredRHS =[1/4, 0, 0; 0, 0, 0; 0,1,-1;1/12,2/3,-2/3];
if ~and((resultLHS==desiredLHS) & (norm(resultRHS - desiredRHS)<1E-8)) then pause; end;

printf("testPLQboundedLHS\n");
plqf=[-5,0,0,%inf;%inf,1,0,5];
desired = [-10, 0, -5, -30;%inf,1/4,0,-5];          
result= plq_lft(plqf);
result2 = mikeplq_lft(plqf);
if ~and(result==desired) then pause; end;
if ~and(result2==desired) then pause; end;

printf("testPLQboundedRHS\n");
plqf=[-5,1,0,5;%inf,0,0,%inf];
desired = [-10, 1/4, 0, -5;%inf,0,-5,-30];          
result= plq_lft(plqf);
result2 = mikeplq_lft(plqf);
if ~and(result==desired) then pause; end;
if ~and(result2==desired) then pause; end;

printf("testPiecewiseLinear\n");
plqf=plq_build(linspace(-2,2,10),exp,exp,%f);
result= plq_lft(plqf);
desired = mikeplq_lft(plqf);
if ~and(result==desired) then pause; end;

printf("testNonconvex\n");
plqf=[-1,0,-1,-1;0,0,1,1;1,0,-1,1;%inf,0,1,-1];
result= plq_lft(plqf,%f);
desired = [-1,0,0,%inf;0,0,-1,0;1,0,1,0;%inf,0,0,%inf];
if ~and(result==desired) then pause; end;
