// Author:   Mike Trienis
// For:      Dr. Yves Lucet
// Whatsit:  A test file for plq_max, adds two piecewise linear quadratic functions. 

//L: Linear, Q: Quadratic, I: Indicator, PW: Piecewise

// <-- NO CHECK REF -->

printf("testLLMax\n");
plqf1 = [%inf,0,1,0];
plqf2 = [%inf,0,-1,0];
result = plq_max(plqf1,plqf2);
//x=linspace(-5,5,25)';
//ymax = plq_eval(result,x);
// plot2d(x,ymax);
desired = [0,0,-1,0;%inf,0,1,0];          
if ~and(result==desired) then pause; end;

printf("testQLMax\n");
plqf = [%inf,1,0,0];
plqg = [%inf,0,0,1];
result = plq_max(plqf,plqg);
//x=linspace(-5,5,25)';
//ymax = plq_eval(result,x);
//plot2d(x,ymax);
desired = [-1,1,0,0;1,0,0,1;%inf,1,0,0];         
if ~and(result==desired) then pause; end;

printf("testQLQMax\n");
plqf1 = [-1,1,0,0;1,0,0,1;%inf,1,0,0];
plqf2 = [0,1,0,0;2,0,1,0;%inf,1,0,-2];
result = plq_max(plqf1,plqf2);
result = plq_clean(result);
//x=linspace(-5,5,100)';
//f0=plq_eval(result,x);
//f1=plq_eval(plqf1,x);
//f2=plq_eval(plqf2,x);
//plot2d(x,[f0,f1,f2]);
//a=gca(); // Handle on axes entity
//a.thickness=3;
//poly1= a.children.children(3); //store polyline handle into poly1
//poly1.foreground = 2; // another way to change the style
//poly1.thickness = 3;
desired = [-1,1,0,0;1,0,0,1;%inf,1,0,0]; 
if ~and(result==desired) then pause; end;

printf("testQLQ2Max\n");
plqf1 = [0,0,-2,0;%inf,0,2,0];
plqf2 = [0,0,-1,1;%inf,0,1,1];
result = plq_max(plqf1,plqf2);
result = plq_clean(result);
//x=linspace(-5,5,100)';
//f0=plq_eval(result,x);
//f1=plq_eval(plqf1,x);
//f2=plq_eval(plqf2,x);
//plot2d(x,[f0,f1,f2]);
//a=gca(); // Handle on axes entity
//a.thickness=3;
//poly1= a.children.children(3); //store polyline handle into poly1
//poly1.foreground = 2; // another way to change the style
//poly1.thickness = 3;
desired = [-1,0,-2,0;0,0,-1,1;1,0,1,1;%inf,0,2,0]; 
if ~and(result==desired) then pause; end;

printf("testQQMax\n");
plqf1 = [%inf,1,0,0];
plqf2 = [%inf,1/10,0,1];
result = plq_max(plqf1,plqf2);
//x=linspace(-5,5,100)';
//f0=plq_eval(result,x);
//f1=plq_eval(plqf1,x);
//f2=plq_eval(plqf2,x);
//plot2d(x,[f0,f1,f2]);
//a=gca(); // Handle on axes entity
//a.thickness=3;
//poly1= a.children.children(3); //store polyline handle into poly1
//poly1.foreground = 2; // another way to change the style
//poly1.thickness = 3;
desired = [- 1.0540926,1,0,0;1.0540926,0.1,0,1;%inf,1,0,0]; 
if ~and(result(:,2:$)==desired(:,2:$)) then pause; end;

printf("testQQMaxdl\n");
plqf1 = [%inf,1,0,0];
plqf2 = [%inf,1,2,-1];
result = plq_max(plqf1,plqf2);
//x=linspace(-5,5,100)';
//f0=plq_eval(result,x);
//f1=plq_eval(plqf1,x);
//f2=plq_eval(plqf2,x);
//plot2d(x,[f0,f1,f2]);
//a=gca(); // Handle on axes entity
//a.thickness=3;
//poly1= a.children.children(3); //store polyline handle into poly1
//poly1.foreground = 2; // another way to change the style
//poly1.thickness = 3;
desired = [0.5,1,0,0;%inf,1,2,-1]; 
if ~and(result==desired) then pause; end;

printf("testQQMaxdq1\n");
plqf1 = [%inf,1,0,0];
plqf2 = [%inf,-1,2,-1];
result = plq_max(plqf1, plqf2);
//x=linspace(-5,5,100)';
//f0=plq_eval(result,x);
//f1=plq_eval(plqf1,x);
//f2=plq_eval(plqf2,x);
//plot2d(x,[f0,f1,f2]);
//a=gca(); // Handle on axes entity
//a.thickness=3;
//poly1= a.children.children(3); //store polyline handle into poly1
//poly1.foreground = 2; // another way to change the style
//poly1.thickness = 3;
desired = [%inf,1,0,0];
if ~isEqual(result, desired) then pause; end;

printf("testQQMaxdq2\n");
plqf1 = [%inf,1,0,0];
plqf2 = [%inf,-1,0,0];
result = plq_max(plqf1, plqf2);
//x=linspace(-5,5,100)';
//f0=plq_eval(result,x);
//f1=plq_eval(plqf1,x);
//f2=plq_eval(plqf2,x);
//plot2d(x,[f0,f1,f2]);
//a=gca(); // Handle on axes entity
//a.thickness=3;
//poly1= a.children.children(3); //store polyline handle into poly1
//poly1.foreground = 2; // another way to change the style
//poly1.thickness = 3;
desired = [%inf,1,0,0];
if ~isEqual(result, desired) then pause; end;

printf("testQLQMax1\n");
plqf1=[1,1,0,0;3, 0, 2, -1;%inf,3,-16,26];
plqf2=[-1,1,0,0;0,1,0,0;1, 0, 1, 0;%inf,3, -4, 2];
result = plq_max(plqf1,plqf2);
result = plq_clean(result);
//x=linspace(-5,5,100)';
//f0=plq_eval(result,x);
//f1=plq_eval(plqf1,x);
//f2=plq_eval(plqf2,x);
//plot2d(x,[f0,f1,f2]);
//a=gca(); // Handle on axes entity
//a.thickness=3;
//poly1= a.children.children(3); //store polyline handle into poly1
//poly1.foreground = 2; // another way to change the style
//poly1.thickness = 3;
desired = [0,1,0,0;1,0,1,0;%inf,3,-4,2]; 
if ~and(result==desired) then pause; end;

printf("testII1Max\n");
plqf1 = [5,0,0,2];
plqf2 = [5,0,0,5];
result = plq_max(plqf1,plqf2);
desired = [5,0,0,5]; 
if ~and(result==desired) then pause; end;

printf("testII2Max\n");
plqf1 = [3,0,0,2];
plqf2 = [5,0,0,5];
result = plq_max(plqf1,plqf2);
desired = [%inf,0,0,%inf]; 
if ~and(result==desired) then pause; end;

printf("testII3Max\n");
plqf1 = [5,0,0,2];
plqf2 = [3,0,0,5];
result = plq_max(plqf1,plqf2);
desired = [%inf,0,0,%inf]; 
if ~and(result==desired) then pause; end;

printf("testQIMax\n");
plqf1 = [%inf,1,0,0];
plqf2 = [2,0,0,5];
result = plq_max(plqf1,plqf2);
desired = [2,0,0,5];
if ~and(result==desired) then pause; end;

printf("testIQMax\n");
plqf1 = [2,0,0,5];
plqf2 = [%inf,1,0,0];
result = plq_max(plqf1,plqf2);
desired = [2,0,0,5];
if ~and(result==desired) then pause; end;

printf("testIQ2Max\n");
plqf1 = [2,0,0,3];
plqf2 = [%inf,1,0,0];
result = plq_max(plqf1,plqf2);
desired = [2,0,0,4];
if ~and(result==desired) then pause; end;

printf("testQI2Max\n");
plqf1 = [%inf,1,0,0];	
plqf2 = [2,0,0,3];
result = plq_max(plqf1,plqf2);
desired = [2,0,0,4]; 
if ~and(result==desired) then pause; end;

//Graphical Test
//function [b] = testExpMaxQ()
//  b = %f;
//  x=linspace(0,5,50)';
//  
//  plqf1 = plq_build(x,exp,exp); 
//  //plqf2 = [%inf,1,0,2];  
//  plqf2 = [%inf,1,0,2];
//  result = plq_addminmax(plqf1,plqf2,2);
//  
//  f0=plq_eval(result,x);
//  f1=plq_eval(plqf1,x);
//  f2=plq_eval(plqf2,x);
//  
//  plot2d(x,[f0,f1,f2],rect=[0,0,2.5,10]);
//  
//  a=gca(); // Handle on axes entity
//  a.thickness=3;
//  poly1= a.children.children(3); //store polyline handle into poly1
//  poly1.foreground = 2; // another way to change the style
//  poly1.thickness = 3; 
//  //
// 
//endfunction

//Graphical Test
//function [b] = testSinMaxZero()
//  b = %f;
//  x=linspace(0,15,150)';
//  
//  plqf1 = plq_build(x,sin,cos); //ROW 13, ROW 14 (Non-increasing x values) BUG! --or f must be convex
//  //plqf2 = [%inf,1,0,2];  
//  plqf2 = [%inf,0,0,0];
//  result = plq_addminmax(plqf1,plqf2,2);
//  
//  f0=plq_eval(result,x);
//  f1=plq_eval(plqf1,x);
//  f2=plq_eval(plqf2,x);
//  
//  plot2d(x,[f0,f1,f2]);
//  
//  a=gca(); // Handle on axes entity
//  a.thickness=3;
//  poly1= a.children.children(3); //store polyline handle into poly1
//  poly1.foreground = 2; // another way to change the style
//  poly1.thickness = 3; 
//  
// 
//endfunction
