// Author:   	Mike Trienis
// For:      	Dr. Yves Lucet
// Whatsit:  	A test file for the piecewise quadratic moreau envelope which uses
//		plq_lft as a wrapper

// <-- NO CHECK REF -->

printf("testMELineWrapper\n");
//ME-Line Y=X+1
lambda=1;
fctn = [%inf,0,1,1];
result = plq_me(fctn,lambda)
desired = [%inf, 0, 1, 1/2]         
if ~and(result==desired) then pause; end;

printf("testMEQuadraticWrapper\n");
lambda=1;
fctn = [%inf,1/2,0,0];
result = plq_me(fctn,lambda)
desired = [%inf, 1/4, 0, 0];         
if ~and(result==desired) then pause; end;

printf("testMEIndicatorWrapper\n");
lambda = 1;
plqf = [5,0,0,1];
result = plq_me(plqf,lambda);
desired = [%inf,0.5,- 5, 13.5];
if ~and(result==desired) then pause; end;

printf("testMEnonconvex\n");
lambda = 1;plqf=[-1,0,-1,-1;0,0,1,1;1,0,-1,1;%inf,0,1,-1];
result = plq_me(plqf,lambda,%f);
desired = [-2,0,-1,-1.5;0,0.5,1,0.5;2,0.5,-1,0.5;%inf,0,1,-1.5];
if ~and(result==desired) then pause; end;

printf("testMaxScale1\n");
f = [0,-1,0,0;%inf,-2,0,0];
desired = -1/2/(-2);
result = plq_me_max_scale(f);
if ~isEqual(desired, result) then pause; end;

printf("testMaxScale2\n");
f = [0,1,0,0;%inf,0,1,0];
desired = %inf;
result = plq_me_max_scale(f);
if ~isEqual(desired, result) then pause; end;

printf("testMaxScale3\n");
f1 = [0,-1,0,0;%inf,-2,0,0];
f2 = [1,0,1,0;2,0,-1,2;%inf,-3,0,0];
m1 = plq_me_max_scale(f1);
m2 = plq_me_max_scale(f2);
m = plq_me_max_scale(f1, f2);
if ~(isEqual(m, 1/6) & m == min(m1, m2)) then pause; end;
